/* original parser id follows */
/* yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93" */
/* (use YYMAJOR/YYMINOR for ifdefs dependent on parser version) */

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20170709

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)
#define YYENOMEM       (-2)
#define YYEOF          0

#ifndef yyparse
#define yyparse    oprs_yyparse
#endif /* yyparse */

#ifndef yylex
#define yylex      oprs_yylex
#endif /* yylex */

#ifndef yyerror
#define yyerror    oprs_yyerror
#endif /* yyerror */

#ifndef yychar
#define yychar     oprs_yychar
#endif /* yychar */

#ifndef yyval
#define yyval      oprs_yyval
#endif /* yyval */

#ifndef yylval
#define yylval     oprs_yylval
#endif /* yylval */

#ifndef yydebug
#define yydebug    oprs_yydebug
#endif /* yydebug */

#ifndef yynerrs
#define yynerrs    oprs_yynerrs
#endif /* yynerrs */

#ifndef yyerrflag
#define yyerrflag  oprs_yyerrflag
#endif /* yyerrflag */

#ifndef yylhs
#define yylhs      oprs_yylhs
#endif /* yylhs */

#ifndef yylen
#define yylen      oprs_yylen
#endif /* yylen */

#ifndef yydefred
#define yydefred   oprs_yydefred
#endif /* yydefred */

#ifndef yydgoto
#define yydgoto    oprs_yydgoto
#endif /* yydgoto */

#ifndef yysindex
#define yysindex   oprs_yysindex
#endif /* yysindex */

#ifndef yyrindex
#define yyrindex   oprs_yyrindex
#endif /* yyrindex */

#ifndef yygindex
#define yygindex   oprs_yygindex
#endif /* yygindex */

#ifndef yytable
#define yytable    oprs_yytable
#endif /* yytable */

#ifndef yycheck
#define yycheck    oprs_yycheck
#endif /* yycheck */

#ifndef yyname
#define yyname     oprs_yyname
#endif /* yyname */

#ifndef yyrule
#define yyrule     oprs_yyrule
#endif /* yyrule */
#define YYPREFIX "oprs_yy"

#define YYPURE 0

#line 2 "oprs-parser.y"



#include "config.h"

#ifdef VXWORKS
#include "vxWorks.h"
#include "stdioLib.h"
#else
#include <stdio.h>
#ifndef WIN95
#include <sys/file.h>
#endif
#endif

#include "oprs-lex.h"


#include "constant.h"
#include "macro.h"
#include "opaque.h"
#include "shashPack.h"
#include "shashPack_f.h"

#include "oprs-type.h"

#ifdef GRAPHIX
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#endif

#include "op-structure.h"
#include "oprs.h"
#include "help_f.h"
#include "oprs-print.h"
#include "oprs-sprint.h"
#include "oprs_f.h"
#include "op-default.h"
#include "database.h"
#include "oprs-pred-func.h"
#include "relevant-op.h"
#include "parser-funct.h"
#include "oprs-main.h"
#include "top-lev.h"
#include "oprs-profiling.h"

#ifdef GRAPHIX
#include "xoprs-main.h"
#endif

#include "yy-funct_f.h"
#include "oprs-type_f.h"
#include "oprs-print_f.h"
#include "oprs-sprint_f.h"
#include "op-structure_f.h"
#include "top-structure_f.h"
#include "database_f.h"
#include "op-compiler_f.h"
#include "fact-goal_f.h"
#include "parser-funct_f.h"
#include "unification_f.h"
#include "relevant-op_f.h"
#include "soak_f.h"
#include "other_proto.h"
#include "oprs-send-m_f.h"
#include "oprs-init_f.h"
#include "int-graph_f.h"
#include "conditions_f.h"
#include "oprs-pred-func_f.h"
#include "type_f.h"
#include "oprs-array_f.h"
#include "top-lev_f.h"
#include "oprs-profiling_f.h"
#include "op-dump-load_f.h"
#include "ltdl-loader_f.h"

char *node_name;
PString type_string;
Node_Type node_type;
int node_x, node_y, visible, text_dx, text_dy, string_width, fill_lines;
Slist *text, *graphic, *step_list;
Slist *edge_location;
long int read_check_sum;
PBoolean load_ok;


#ifdef YYSTYPE
#undef  YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#endif
#ifndef YYSTYPE_IS_DECLARED
#define YYSTYPE_IS_DECLARED 1
#line 90 "oprs-parser.y"
typedef union {
    double    		real;        
    int    		integer;    
    long long int	long_long;    
    void    		*pointer;    
    char    		*string;    
    Symbol    		symbol;    
    int    		cmd;        
    PBoolean		bool;
    TermList 		list_term;
    ExprList 		list_expr;
    PropertyList 	prop_list;
    VarList 		var_list;
    Property		*prop;
    Add_Del_List	add_del_list;
    Envar       	*var;
    Term 		*term;
    Pred_Func_Rec	*pred_func_rec;
    Action_Field	*action_field;
    Expression 		*expr;
    Double_Node		*dn;
    NodeList 		nl;
    EdgeList 		el;
    Node_Type 		nt;
    Slist *		list;
} YYSTYPE;
#endif /* !YYSTYPE_IS_DECLARED */
#line 222 "oprs-parser.c"

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
# ifdef YYPARSE_PARAM_TYPE
#  define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
# else
#  define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
# endif
#else
# define YYPARSE_DECL() yyparse(void)
#endif

/* Parameters sent to lex. */
#ifdef YYLEX_PARAM
# define YYLEX_DECL() yylex(void *YYLEX_PARAM)
# define YYLEX yylex(YYLEX_PARAM)
#else
# define YYLEX_DECL() yylex(void)
# define YYLEX yylex()
#endif

/* Parameters sent to yyerror. */
#ifndef YYERROR_DECL
#define YYERROR_DECL() yyerror(const char *s)
#endif
#ifndef YYERROR_CALL
#define YYERROR_CALL(msg) yyerror(msg)
#endif

extern int YYPARSE_DECL();

#define REAL_TK 257
#define POINTER_TK 258
#define INTEGER_TK 259
#define LONG_LONG_TK 260
#define QSTRING_TK 261
#define SYMBOL_TK 262
#define COMMENT_TK 263
#define LOGICAL_VAR_TK 264
#define PROGRAM_VAR_TK 265
#define HELP_TK 266
#define ADD_TK 267
#define CONCLUDE_TK 268
#define CONSULT_TK 269
#define DECLARE_TK 270
#define DELETE_TK 271
#define ECHO_TK 272
#define EMPTY_TK 273
#define INCLUDE_TK 274
#define LIST_TK 275
#define LOAD_TK 276
#define RELOAD_TK 277
#define RECEIVE_TK 278
#define RESET_TK 279
#define SEND_TK 280
#define SET_TK 281
#define SHOW_TK 282
#define STAT_TK 283
#define TRACE_TK 284
#define UNIFY_TK 285
#define DB_TK 286
#define FACT_TK 287
#define GOAL_TK 288
#define TSYM_TK 289
#define INTENTION_TK 290
#define OP_TK 291
#define OPF_TK 292
#define KERNEL_TK 293
#define CONDITION_TK 294
#define COMPLETION_TK 295
#define META_TK 296
#define EVAL_TK 297
#define POST_TK 298
#define PARALLEL_TK 299
#define PROFILING_TK 300
#define SILENT_TK 301
#define FRAME_TK 302
#define SOAK_TK 303
#define THREADING_TK 304
#define INTEND_TK 305
#define SUC_FAIL_TK 306
#define ALL_TK 307
#define ON_TK 308
#define OFF_TK 309
#define VERSION_TK 310
#define COPYRIGHT_TK 311
#define MEMORY_TK 312
#define FF_TK 313
#define BE_TK 314
#define CWP_TK 315
#define RELEVANT_TK 316
#define APPLICABLE_TK 317
#define TAKE_STDIN_TK 318
#define DISCONNECT_TK 319
#define QUIT_TK 320
#define TEXT_TK 321
#define GRAPHIC_TK 322
#define CALL_EXTERNAL_TK 323
#define DUMMY_TK 324
#define SAVE_TK 325
#define UNDECLARE_TK 326
#define TYPE_TK 327
#define EVALUABLE_TK 328
#define AC_TK 329
#define EXTERNAL_TK 330
#define PREDICATE_TK 331
#define FUNCTION_TK 332
#define REQUIRE_TK 333
#define SYM_TK 334
#define VARIABLE_TK 335
#define OPRS_DATA_PATH_TK 336
#define OP_PREDICATE_TK 337
#define DUMP_TK 338
#define MAKE_TK 339
#define WORLD_TK 340
#define STEP_TK 341
#define NEXT_TK 342
#define HALT_TK 343
#define RUN_TK 344
#define STATUS_TK 345
#define FAILURE_TK 346
#define USER_TK 347
#define OPF_VERSION1 348
#define OPF_VERSION2 349
#define TYPE_SEP_TK 350
#define FT_INVOCATION_TK 351
#define FT_CONTEXT_TK 352
#define FT_ACTION_TK 353
#define FT_CALL_TK 354
#define FT_SETTING_TK 355
#define FT_PROPERTIES_TK 356
#define FT_DOCUMENTATION_TK 357
#define FT_EFFECTS_TK 358
#define NT_PROCESS_TK 359
#define NT_START_TK 360
#define NT_END_TK 361
#define NT_ELSE_TK 362
#define NT_THEN_TK 363
#define NT_IF_TK 364
#define ET_GOAL_TK 365
#define ET_ELSE_TK 366
#define ET_THEN_TK 367
#define ET_IF_TK 368
#define SPEC_ACT_TK 369
#define RESET_DOT_TK 370
#define OR_TK 371
#define TEMP_CONCLUDE_TK 372
#define RETRACT_TK 373
#define AND_TK 374
#define COND_ADD_TK 375
#define COND_DEL_TK 376
#define OP_LISP_TK 377
#define CP_LISP_TK 378
#define OP_ARRAY_TK 379
#define CP_ARRAY_TK 380
#define OPENP_TK 381
#define CLOSEP_TK 382
#define ACHIEVE_TK 383
#define TEST_TK 384
#define PRESERVE_TK 385
#define MAINTAIN_TK 386
#define WAIT_TK 387
#define CALL_TK 388
#define EOF_TK 389
#define TFT_INVOCATION_TK 390
#define TFT_CONTEXT_TK 391
#define TFT_SETTING_TK 392
#define TFT_BODY_TK 393
#define TFT_CALL_TK 394
#define TFT_PROPERTIES_TK 395
#define TFT_DOCUMENTATION_TK 396
#define TFT_EFFECTS_TK 397
#define TFT_ACTION_TK 398
#define WHILE_TK 399
#define DO_TK 400
#define PAR_TK 401
#define DEFOP_TK 402
#define IF_TK 403
#define ELSE_TK 404
#define GOTO_TK 405
#define BREAK_TK 406
#define ELSEIF_TK 407
#define LABEL_TK 408
#define YYERRCODE 256
typedef short YYINT;
static const YYINT oprs_yylhs[] = {                      -1,
    0,    0,   59,   58,   60,   62,   58,   64,   58,   65,
   67,   58,   68,   69,   58,   70,   58,   71,   58,   72,
   73,   58,   74,   58,   58,   58,   58,   58,   58,   58,
   58,   58,   58,   58,   58,   58,   58,   75,   76,   58,
   77,   78,   58,   79,   80,   58,   81,   82,   58,   83,
   84,   58,   85,   86,   58,   58,   58,   58,   58,   58,
   58,   58,   58,   58,   87,   58,   88,   58,   89,   58,
   58,   90,   58,   91,   58,   92,   58,   93,   58,   94,
   58,   95,   58,   96,   58,   97,   58,   58,   58,   98,
   58,   99,   58,  100,   58,   58,  102,   58,  104,   58,
  105,   58,  106,   58,  107,   58,  108,   58,  109,   58,
  110,   58,  111,   58,  112,   58,  113,   58,   58,   58,
   58,   58,   58,   58,   58,   58,  114,   58,   58,  115,
   58,   58,  116,   58,   58,   58,   58,   58,   58,   58,
   58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
   58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
   58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
   58,   58,   58,   58,   58,   58,   58,   58,   58,   58,
   58,   58,   58,   58,   58,   58,   58,   58,  120,   58,
   58,   58,  122,   58,  123,   58,   58,   58,   58,   58,
   58,   58,  117,  118,    5,    5,  101,  101,  103,  103,
  124,  124,   19,   19,  121,  125,  119,   61,   61,    1,
    1,  126,  126,  126,  128,   66,   66,  127,  130,  127,
  131,  132,  127,  134,  127,   57,   57,  129,  129,  129,
   63,   63,  137,  135,  139,  139,  143,  141,  144,  142,
  145,  142,  146,  142,  147,  142,  148,  142,  149,  142,
   10,    9,  138,  138,  152,  150,  153,  151,  154,  151,
  155,  151,  156,  151,  157,  151,  158,  151,  159,  151,
  160,  151,    2,    3,    7,    4,    8,    6,  161,   28,
   27,   27,   34,   34,   34,   29,  162,   29,   50,  163,
   50,   51,   51,   15,   15,  164,   35,  165,   25,  166,
   26,  167,   26,   26,  168,   24,  140,  140,  171,  169,
  169,  172,   31,   54,   55,   55,   11,   13,   12,  173,
  170,  174,  170,  175,  170,  176,  170,  133,  133,  133,
  178,  136,  177,  180,  180,  181,  181,  181,  181,  181,
  181,  181,  181,  179,  184,  185,  186,  187,  188,  189,
  183,  190,  182,   37,   39,   39,   38,   38,   38,   38,
   38,   38,   38,   38,   38,   43,   45,   46,   48,   47,
   49,   49,   49,   44,   40,   41,   42,   56,   56,   22,
   22,   22,   22,   36,   36,   33,   33,   32,   32,   30,
   30,   20,   20,   21,   21,   16,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   23,   23,   23,   23,   23,
   23,   23,   23,   23,   23,   53,   53,   52,   52,   52,
   14,   18,   17,
};
static const YYINT oprs_yylen[] = {                       2,
    1,    1,    0,    4,    0,    0,    6,    0,    4,    0,
    0,    6,    0,    0,    7,    0,    4,    0,    4,    0,
    0,    6,    0,    4,    2,    3,    2,    2,    2,    2,
    3,    2,    3,    2,    2,    2,    2,    0,    0,    7,
    0,    0,    7,    0,    0,    7,    0,    0,    7,    0,
    0,    7,    0,    0,    7,    2,    2,    3,    2,    2,
    3,    2,    2,    2,    0,    4,    0,    4,    0,    4,
    3,    0,    4,    0,    5,    0,    5,    0,    5,    0,
    5,    0,    4,    0,    5,    0,    5,    3,    3,    0,
    3,    0,    3,    0,    5,    3,    0,    4,    0,    4,
    0,    4,    0,    4,    0,    4,    0,    4,    0,    5,
    0,    4,    0,    4,    0,    4,    0,    4,    1,    1,
    1,    1,    1,    1,    1,    2,    0,    3,    3,    0,
    3,    3,    0,    3,    3,    2,    2,    2,    2,    2,
    2,    2,    2,    3,    3,    3,    4,    4,    5,    5,
    4,    4,    4,    4,    3,    3,    3,    3,    3,    4,
    4,    4,    4,    4,    4,    4,    4,    5,    5,    4,
    3,    3,    3,    3,    4,    5,    3,    3,    3,    3,
    3,    3,    4,    4,    4,    4,    3,    3,    0,    3,
    3,    2,    0,    4,    0,    4,    3,    1,    2,    1,
    1,    2,    3,    3,    1,    1,    1,    3,    3,    3,
    0,    4,    1,    3,    1,    0,    2,    3,    3,    1,
    1,    0,    2,    2,    0,    2,    2,    0,    0,    5,
    0,    0,    9,    0,    4,    0,    2,    0,    2,    2,
    1,    1,    0,   13,    0,    2,    0,    4,    0,    7,
    0,    7,    0,    7,    0,    7,    0,    7,    0,    7,
    1,    1,    0,    2,    0,    4,    0,    9,    0,    9,
    0,    9,    0,    9,    0,    9,    0,    9,    0,    9,
    0,    9,    1,    1,    1,    1,    1,    1,    0,    2,
    0,    1,    0,    1,    1,    0,    0,    2,    0,    0,
    4,    0,    2,    0,    1,    0,    2,    0,    2,    0,
    6,    0,    8,    1,    0,    5,    0,    2,    0,    4,
    2,    0,    2,    3,    0,    5,    1,    1,    1,    0,
   11,    0,   11,    0,    5,    0,    5,    0,    2,    2,
    0,    6,    2,    1,    2,    1,    1,    1,    1,    1,
    1,    1,    1,    2,    2,    2,    2,    2,    2,    2,
    2,    0,    3,    3,    0,    2,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    1,    1,    2,    1,    2,
    2,    4,    4,    4,    5,    6,    4,    0,    2,    1,
    3,    1,    3,    0,    1,    3,    2,    1,    2,    4,
    4,    1,    1,    0,    2,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    1,    2,    4,    4,    3,
    1,    1,    1,
};
static const YYINT oprs_yydefred[] = {                    0,
    0,  198,  215,    0,    0,    0,    0,    0,    0,   90,
    0,    0,    0,  193,    0,  195,    0,    0,    0,    0,
    3,  125,  124,  123,  200,    0,    0,    0,   92,    0,
  119,  120,  121,  122,  201,    2,    0,    1,    0,    0,
    0,  220,  221,  202,    0,    0,    0,    0,    0,    0,
   99,  109,  111,  107,   94,  101,  103,   97,  105,    0,
   16,   18,    0,    0,  216,    0,    0,    0,   25,   27,
   37,   29,   30,   28,    0,   36,   35,   34,    0,   32,
    5,    0,   10,    0,   82,   80,    0,   20,    0,  126,
  138,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   57,   59,   23,   60,  140,    0,  142,  141,
  139,    0,   56,  143,    0,   62,   64,   63,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  199,   65,  113,
  117,  115,    0,   67,   69,   72,    0,    0,  136,  137,
    0,  192,  129,  128,  135,  203,  204,  134,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  132,    0,    0,
  131,  191,  190,    0,   88,   89,  432,   91,   33,   31,
   26,    0,    0,  236,    0,   86,   84,    0,    0,   74,
   76,   78,    0,    0,    0,    0,    0,  205,  206,  145,
    0,    0,    0,    0,  159,  146,  156,  158,  157,  155,
  144,    0,   58,   96,   61,  182,    0,  178,  177,    0,
  181,  179,  180,    0,  187,  173,  174,  188,    0,    0,
   50,   53,  171,   38,   41,  172,   44,   47,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   93,    0,    0,    0,   71,  403,
    0,    0,    0,  402,  197,    0,  211,  100,    0,  112,
  108,    0,  102,  104,  207,  236,   98,  106,  327,   17,
  406,   19,  217,    6,    0,    9,  242,  241,    0,   11,
    0,    0,   83,    0,    0,    0,    0,   21,  194,  196,
    0,  147,    0,  148,  151,  154,  152,  153,   24,  184,
  183,    0,  175,  185,  186,    0,    0,    0,    0,    0,
    0,  165,  164,  160,  166,  167,  161,  170,  162,  163,
    0,    0,    4,  433,   66,  114,  118,  116,   68,   70,
   73,    0,    0,    0,    0,    0,    0,  110,   95,    0,
    0,    0,  243,  237,   14,    0,   87,   85,   81,   75,
   77,   79,    0,  149,  150,  176,   51,   54,   39,   42,
   45,   48,  168,  169,  391,  393,  401,  410,  409,  407,
  408,  411,    0,    0,    0,    0,  400,  412,  413,  405,
  414,  209,    0,  210,  208,    0,    7,  341,    0,    0,
    0,   12,    0,   22,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  263,   15,  227,    0,  226,   52,   55,   40,   43,   46,
   49,  214,  423,  425,  424,  415,  419,  417,  418,  416,
  421,  422,  420,  212,    0,  219,  218,  223,  289,    0,
    0,    0,  229,  231,    0,  354,    0,  342,    0,    0,
  362,    0,    0,    0,  306,  308,    0,  344,  346,  347,
  348,  349,  350,  351,  352,  353,  265,    0,  264,  238,
    0,    0,    0,  290,    0,  294,  295,  356,  357,    0,
    0,  355,  292,  300,  358,  305,  359,  360,    0,  361,
    0,  345,    0,  245,    0,  236,  340,    0,  235,  339,
  397,  398,    0,  298,  365,  363,  302,    0,  395,  307,
    0,  314,  309,  267,  271,  281,  269,  273,  275,  277,
  279,    0,    0,  230,  239,  240,    0,  396,  399,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  266,  247,    0,  246,    0,  377,    0,  364,    0,
  379,    0,  376,  366,  369,  370,  371,  367,  368,  372,
  373,  374,  375,    0,  301,  303,    0,    0,  404,  329,
  289,    0,  308,    0,    0,    0,    0,  306,    0,  317,
  238,    0,  365,  388,    0,  378,  380,    0,  431,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  255,  259,  257,  249,  251,  253,    0,    0,    0,
  365,    0,    0,  365,    0,  430,    0,    0,  315,    0,
  426,    0,  316,  283,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  248,    0,
  319,    0,  318,  233,    0,    0,  387,  389,    0,  384,
  429,  428,  311,    0,  427,  284,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  321,    0,  244,  385,    0,  365,    0,    0,  288,  285,
    0,    0,    0,    0,    0,    0,    0,    0,  261,    0,
    0,    0,    0,    0,    0,  330,  334,  336,  332,    0,
  386,    0,  383,  313,  286,    0,    0,    0,    0,    0,
    0,    0,    0,  262,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  320,  287,  268,  272,  282,  270,
  274,  276,  278,  280,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  256,  260,  258,  250,  252,  254,
  328,    0,    0,    0,    0,  322,  335,  337,  322,    0,
    0,    0,  325,    0,  323,    0,    0,    0,    0,    0,
  324,    0,    0,    0,    0,    0,    0,  331,  333,  326,
};
static const YYINT oprs_yydgoto[] = {                    37,
   44,  635,  667,  716,  200,  736,  691,  737,  725,  700,
  280,  581,  762,  600,  497,  282,  335,  178,  388,  263,
  345,  264,  390,  522,  500,  523,  492,  456,  489,  391,
  770,  513,  487,  488,  498,  520,  516,  564,  540,  565,
  566,  567,  568,  569,  570,  571,  572,  573,  625,  495,
  541,  576,  632,  774,  777,  623,  289,   38,  137,  182,
  397,  351,  286,  183,  185,  402,  356,  184,  400,  169,
  170,  193,  363,  212,  318,  407,  319,  408,  320,  409,
  321,  410,  316,  405,  317,  406,  251,  256,  257,  258,
  295,  296,  297,  189,  188,  292,  291,   68,  143,  163,
  277,  166,  268,  159,  164,  165,  167,  162,  160,  161,
  252,  254,  253,   46,   63,   50,   39,   40,  173,   65,
   41,   89,   92,  347,  174,  419,  425,  403,  505,  480,
  481,  556,  483,  455,  535,  536,  399,  452,  533,  619,
  555,  618,  589,  646,  647,  648,  643,  645,  644,  479,
  532,  503,  544,  547,  545,  548,  549,  550,  551,  546,
  457,  490,  517,  499,  501,  577,  578,  543,  653,  710,
  682,  771,  731,  734,  732,  733,  450,  420,  451,  467,
  468,  469,  470,  471,  472,  473,  474,  475,  476,  491,
};
static const YYINT oprs_yysindex[] = {                  243,
 -344,    0,    0, -222, -210,  351,  -61, -220,  128,    0,
  445,  168, -245,    0, -166,    0,  465,  413, -230,  355,
    0,    0,    0,    0,    0, -195, -189, -206,    0,   43,
    0,    0,    0,    0,    0,    0,    0,    0, -301, -301,
 -229,    0,    0,    0, -271, -301, -260, -155, -137, -301,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -258,
    0,    0, -301, -177,    0,  -76,  -73,  -18,    0,    0,
    0,    0,    0,    0,  -99,    0,    0,    0,  -21,    0,
    0,    0,    0,  -84,    0,    0,   15,    0,   29,    0,
    0,   40,    1,   42,  -19,   -9,   -9,   -9,   -9,   -9,
   -9,   88,    0,    0,    0,    0,    0,   80,    0,    0,
    0,   95,    0,    0,   31,    0,    0,    0,   -9,   98,
   -9,   -9, -120,   -9,   -9,   33,   -9,   -9,   -9,   -9,
  101,  117,    3,   22,   32,  501, -301,    0,    0,    0,
    0,    0,  -18,    0,    0,    0,  144,  185,    0,    0,
   78,    0,    0,    0,    0,    0,    0,    0, -237,  185,
  185,  185,  199,  185,  185, -203,  185,    0,  208,  211,
    0,    0,    0, -301,    0,    0,    0,    0,    0,    0,
    0,  -18,  105,    0,  -18,    0,    0,  227,  232,    0,
    0,    0,  -18, -301, -301,  -63,   -4,    0,    0,    0,
   -9,   -9,   -9,   -9,    0,    0,    0,    0,    0,    0,
    0,  208,    0,    0,    0,    0,   -9,    0,    0,   -9,
    0,    0,    0, -248,    0,    0,    0,    0,   -9,   -9,
    0,    0,    0,    0,    0,    0,    0,    0,   -9,   -9,
   -9,   -9,   -9,   -9,   -9,   -9,   -9,  204,  212, -301,
  244,  185,  185,  185,    0,  244,  244,  244,    0,    0,
  180,  182,  280,    0,    0,  194,    0,    0,  292,    0,
    0,  285,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, -218,    0,    0,    0,   77,    0,
  297,  306,    0,  321,  -18,  -18,  -18,    0,    0,    0,
   -9,    0,   -9,    0,    0,    0,    0,    0,    0,    0,
    0,   -9,    0,    0,    0,  208,  211,  208,  211,  208,
  211,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   -9,   -9,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  332,  341,  224,   94,  401, -241,    0,    0, -199,
  253,  208,    0,    0,    0,  388,    0,    0,    0,    0,
    0,    0,  388,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  324,  419,  423,  284,    0,    0,    0,    0,
    0,    0,  330,    0,    0,  425,    0,    0,  303,  388,
  298,    0,  305,    0,   -9,   -9,   -9,   -9,   -9,   -9,
  427,  -45,  313,  109,  331,  122,  431, -313,   25,  307,
    0,    0,    0,   73,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  316,
  258,   74,    0,    0,  439,    0, -301,    0,  319,    0,
    0, -301,  320,  444,    0,    0,  258,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  325,    0,    0,
  328,  344,   96,    0, -132,    0,    0,    0,    0, -301,
  334,    0,    0,    0,    0,    0,    0,    0,  335,    0,
  345,    0,  484,    0,  160,    0,    0,  326,    0,    0,
    0,    0,  183,    0,    0,    0,    0,  198,    0,    0,
  353,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  352,  237,    0,    0,    0,  471,    0,    0, -231,
  240,    0,  185,  473,  473,  473,  473,  473,  473,  473,
  473,    0,    0,  357,    0,  365,    0, -183,    0,  488,
    0,  489,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -141,    0,    0,  372,  358,    0,    0,
    0,  319,    0, -301,    0,  320,  444,    0,  382,    0,
    0, -301,    0,    0, -301,    0,    0,  371,    0,  113,
  373,  372,  152,  496,  496,  496,  496,  496,  496,  496,
  496,    0,    0,    0,    0,    0,    0,  374, -239,  257,
    0, -205,  265,    0,  381,    0,  383,  385,    0,  387,
    0, -127,    0,    0,  511,  511,  511,  511,  511,  511,
  511,  511,  473,  473,  473,  473,  473,  473,    0,  402,
    0,  389,    0,    0, -201, -301,    0,    0, -235,    0,
    0,    0,    0,  373,    0,    0,  516,  516,  516,  516,
  516,  516,  516,  516,  516,  516,  516,  516,  516,  516,
    0, -109,    0,    0,  396,    0, -301,  404,    0,    0,
  524,  524,  524,  524,  524,  524,  524,  524,    0,  516,
  516,  516,  516,  516,  516,    0,    0,    0,    0,  405,
    0, -179,    0,    0,    0,  516,  516,  516,  516,  516,
  516,  516,  516,    0,  496,  496,  496,  496,  496,  496,
  473,  473,  473,  473,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  511,  511,  511,  511,  511,  511,
  522,  522,  522,  522,    0,    0,    0,    0,    0,    0,
    0,  473,  473,  473,  473,    0,    0,    0,    0,  409,
 -301,  409,    0,  496,    0,  496,  276,  511,  511,  532,
    0,  524,  524,  534,  516,  516,  416,    0,    0,    0,
};
static const YYINT oprs_yyrindex[] = {                    0,
    0,    0,    0,  414,  421,    0,  422,  438,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -232,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    4,   16,  173,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   18,    0,    0,    0,    0,
    0,    0,   18,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  103,  340,  350,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  286,    0,    0,    0,   18,
    0,    0,  804,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, -234,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    6,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  288,    0,    0,    0,  418,   71,
    0,  452,  469,  477,    0,    0,  426,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -50,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  295,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  470,    0,    0,    0,
    0, -191,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  627,    0,  628, -228,  629,  630,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  508,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  509,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
static const YYINT oprs_yygindex[] = {                    0,
  474, -568, -321, -643,   -5,  153,  -44, -278,  175,  205,
 -207, -480, -664,    0,  308,  218,  -35, -110,    0, -152,
 -365, -310,  293, -578,  311,    0,  312,  317,  314,  -39,
  131,    0,  398,  322,  315,    0,  278,    0, -296,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  215,  323,
    0,    0,    0,  133,    0,    0, -262,    0,    0,    0,
    0,    0,    0,    0,    0, -315,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  327,    0,
    0,    0,    0,    0,  723, -180,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  440,    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 918
static const YYINT oprs_yytable[] = {                   149,
  150,  152,  288,  390,  309,  220,  154,  269,  270,  271,
  158,  273,  274,  350,  278,  392,  650,  225,  413,  415,
  393,  234,  630,  171,  266,   42,  151,  557,   13,   13,
  296,  557,  255,   45,  389,   64,  636,  637,  638,  639,
  640,  641,  642,  279,   43,   47,   88,  404,  717,  718,
  719,  720,  721,  722,  723,  116,  445,  557,  275,  198,
  199,  557,  354,  138,  582,  583,  584,  585,  586,  587,
  588,  284,  310,  310,  290,   43,  117,  353,  260,  148,
  261,  262,  298,  557,  422,  688,  312,  763,  764,  765,
  205,  206,  207,  208,  209,  210,  139,  250,  153,  336,
  337,  338,  389,  118,  389,   48,   49,  140,  367,  155,
  369,  168,  371,  216,  598,  218,  219,  221,  222,  223,
  599,  225,  226,  227,  228,  141,   90,  233,  236,  260,
  142,  261,  262,   91,  283,  156,  261,  262,  785,  786,
  394,  651,  652,  267,  398,  558,  234,  234,    8,  558,
  559,  148,  297,  157,  299,  300,  745,  746,  747,  748,
  749,  750,  675,  676,  677,  678,  679,  680,  686,  560,
  561,  687,  562,  560,  561,  558,  562,  276,  355,  558,
  684,  220,  395,  352,  360,  361,  362,  198,  199,  312,
  302,  304,  172,  656,   60,  305,  306,  307,  308,  560,
  561,  558,  562,  560,  561,  778,  562,  779,  394,  175,
  333,  310,  176,  603,  311,  592,  593,  594,  313,  595,
  339,  340,  341,  314,  315,  560,  561,  301,  562,   61,
   62,  179,  180,  322,  323,  324,  325,  326,  327,  328,
  329,  330,  177,  537,  198,  199,  186,  187,  148,  511,
  751,  752,  753,  754,  664,  706,  707,  708,  709,  390,
  390,  390,  390,  390,  390,  390,  601,  390,  390,  181,
  202,  392,  392,  392,  392,  392,  392,  392,  203,  392,
  392,  766,  767,  768,  769,  204,  303,  196,  197,  389,
  194,  631,  389,  231,  232,  364,  622,  365,  198,  199,
  190,  195,  510,  198,  199,  191,  366,  192,  198,  199,
  198,  199,  234,  235,  668,  669,  670,  671,  672,  673,
  674,  665,  237,  238,  655,  373,  374,  659,  144,  198,
  199,  394,  433,  145,  434,  146,  435,  177,  354,  201,
  394,  394,  394,  394,  394,  394,  394,  394,  211,  147,
  378,  379,  380,  381,  382,  383,  214,  261,  262,  213,
  213,  213,  213,  213,  213,  213,  213,  213,  627,  378,
  379,  380,  381,  382,  383,  215,  261,  262,  224,  448,
  390,  390,  390,  390,  390,  390,  224,  224,  217,  712,
  579,  229,  392,  392,  392,  392,  392,  392,  225,  426,
  427,  428,  429,  430,  431,  148,  447,  230,  378,  379,
  380,  381,  382,  383,   66,  261,  262,  484,   67,  486,
  453,  454,  493,  755,  756,  757,  758,  759,  760,  404,
  404,  404,  404,  404,  404,  259,  404,  404,  738,  739,
  740,  741,  742,  743,  744,  512,  260,  265,  261,  262,
  514,  297,  296,   81,  477,  478,  782,  783,   82,   83,
  272,  296,  296,  296,  296,  296,  296,  296,  296,  279,
  384,  281,  385,  539,  386,  387,  508,  509,  512,  213,
  213,  213,  213,  213,  213,  285,  437,  293,  438,  384,
  439,  385,  294,  386,  331,   84,   85,   86,    1,  441,
  563,  442,  332,  443,  334,   87,  788,  789,    2,    3,
    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,
   14,   15,   16,   17,   18,   19,   20,   21,  384,  342,
  385,  343,  386,  633,  368,  344,  370,   22,  372,  416,
  285,  534,  486,  346,  493,  260,  349,  261,  262,  404,
  348,  404,  621,  404,  404,  624,  315,  357,  315,  315,
   23,   24,   25,  148,  538,   26,  358,   27,   28,  378,
  379,  380,  381,  382,  383,   29,  261,  262,  148,  511,
   30,  359,  563,   31,   32,   33,   34,  378,  379,  380,
  381,  382,  383,  375,  261,  262,  404,  404,  404,  404,
  404,  404,  376,  404,  404,  377,  404,  404,  404,  404,
  404,  404,   35,  404,  404,  563,  685,  553,  554,  563,
  574,  575,  119,  692,  693,  694,  695,  696,  697,  698,
  120,   36,  121,  396,  122,  261,  262,  285,  654,   51,
  123,  124,  125,  401,  126,  515,  657,  624,  459,  460,
  461,  462,  463,  464,  465,  466,  780,  781,  127,  128,
  129,  130,  392,   52,   53,   54,  222,  222,  338,  338,
  131,  132,  563,  411,  412,  133,  134,   55,  414,  417,
  418,   56,   57,  421,   58,  424,  423,   59,  432,  384,
  436,  385,  444,  386,  482,  135,  449,  458,  103,  485,
  494,  136,  104,  105,  496,  504,  106,  384,  506,  385,
  440,  386,  107,  507,  515,  518,  404,  404,  404,  108,
  404,  542,  109,  110,  111,  521,  404,  352,  404,  404,
  404,  775,  354,  552,  580,   69,   70,  590,  602,  112,
  612,  613,  614,  615,  616,  617,  591,  113,  114,  596,
  597,   71,  626,  629,  634,  649,  115,   72,   73,   74,
   93,   94,  660,   95,  661,   96,  662,   97,  663,  666,
  683,  681,   75,   76,  689,   77,   78,  711,  239,   79,
  240,   80,  715,  761,  241,  714,  735,  242,  243,  773,
  784,  244,  787,   98,  127,   99,  100,  790,  101,  293,
  102,  133,  130,  228,  245,  246,  247,  343,  293,  293,
  293,  293,  293,  293,  293,  293,  248,  249,  189,  690,
  690,  690,  690,  690,  690,  690,  690,  699,  699,  699,
  699,  699,  699,  291,  524,  525,  526,  527,  528,  529,
  530,  531,  291,  291,  291,  291,  291,  291,  291,  291,
  299,  232,  724,  724,  724,  724,  724,  724,  304,  299,
  299,  299,  299,  299,  299,  299,  299,  304,  304,  304,
  304,  304,  304,  304,  304,  726,  727,  728,  729,  730,
  701,  702,  703,  704,  705,  293,  291,  299,  304,  381,
  382,  446,  628,  606,  610,  607,  519,  604,  608,  772,
  658,  713,  611,  605,  776,  287,  502,    0,  609,    0,
    0,    0,    0,    0,    0,    0,    0,  620,
};
static const YYINT oprs_yycheck[] = {                    39,
   40,   41,  183,    0,  212,    0,   46,  160,  161,  162,
   50,  164,  165,  276,  167,    0,  256,    0,  384,  385,
  262,  256,  601,   63,  262,  370,  256,  263,  261,  262,
  259,  263,  143,  256,  345,  256,  605,  606,  607,  608,
  609,  610,  611,  262,  389,  256,  292,  363,  692,  693,
  694,  695,  696,  697,  698,  286,  370,  263,  262,  308,
  309,  263,  262,  259,  545,  546,  547,  548,  549,  550,
  551,  182,  264,  265,  185,  389,  307,  285,  262,  381,
  264,  265,  193,  263,  400,  664,  335,  752,  753,  754,
   96,   97,   98,   99,  100,  101,  286,  137,  370,  252,
  253,  254,  413,  334,  415,  316,  317,  314,  316,  370,
  318,  370,  320,  119,  256,  121,  122,  123,  124,  125,
  262,  127,  128,  129,  130,  332,  293,  133,  134,  262,
  337,  264,  265,  300,  174,  291,  264,  265,  782,  783,
  382,  381,  382,  381,  352,  381,  381,  382,  381,  381,
  382,  381,  381,  291,  194,  195,  725,  726,  727,  728,
  729,  730,  643,  644,  645,  646,  647,  648,  404,  405,
  406,  407,  408,  405,  406,  381,  408,  381,  289,  381,
  382,  302,  382,  402,  295,  296,  297,  308,  309,  381,
  196,  197,  370,  399,  256,  201,  202,  203,  204,  405,
  406,  381,  408,  405,  406,  774,  408,  776,  259,  286,
  250,  217,  286,  579,  220,  399,  400,  401,  224,  403,
  256,  257,  258,  229,  230,  405,  406,  291,  408,  291,
  292,  331,  332,  239,  240,  241,  242,  243,  244,  245,
  246,  247,  261,  506,  308,  309,  331,  332,  381,  382,
  731,  732,  733,  734,  382,  365,  366,  367,  368,  256,
  257,  258,  259,  260,  261,  262,  577,  264,  265,  291,
  290,  256,  257,  258,  259,  260,  261,  262,  298,  264,
  265,  762,  763,  764,  765,  305,  291,  287,  288,  600,
  262,  602,  603,  291,  292,  301,  593,  303,  308,  309,
  286,  262,  483,  308,  309,  291,  312,  293,  308,  309,
  308,  309,  291,  292,  636,  637,  638,  639,  640,  641,
  642,  632,  291,  292,  621,  331,  332,  624,  286,  308,
  309,  382,  378,  291,  380,  293,  382,  261,  262,  298,
  391,  392,  393,  394,  395,  396,  397,  398,  261,  307,
  257,  258,  259,  260,  261,  262,  262,  264,  265,  257,
  258,  259,  260,  261,  262,  286,  264,  265,  256,  257,
  258,  259,  260,  261,  262,  345,  264,  265,  346,  419,
  377,  378,  379,  380,  381,  382,  381,  382,  291,  686,
  543,  291,  377,  378,  379,  380,  381,  382,  381,  405,
  406,  407,  408,  409,  410,  381,  382,  291,  257,  258,
  259,  260,  261,  262,  287,  264,  265,  457,  291,  459,
  348,  349,  462,  745,  746,  747,  748,  749,  750,  257,
  258,  259,  260,  261,  262,  292,  264,  265,  717,  718,
  719,  720,  721,  722,  723,  485,  262,  370,  264,  265,
  490,  381,  382,  286,  381,  382,  778,  779,  291,  292,
  262,  391,  392,  393,  394,  395,  396,  397,  398,  262,
  377,  261,  379,  513,  381,  382,  381,  382,  518,  377,
  378,  379,  380,  381,  382,  381,  378,  261,  380,  377,
  382,  379,  261,  381,  291,  328,  329,  330,  256,  378,
  540,  380,  291,  382,  261,  338,  785,  786,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  283,  284,  285,  377,  350,
  379,  350,  381,  382,  317,  256,  319,  295,  321,  256,
  381,  382,  582,  350,  584,  262,  262,  264,  265,  377,
  259,  379,  592,  381,  382,  595,  262,  261,  264,  265,
  318,  319,  320,  381,  382,  323,  261,  325,  326,  257,
  258,  259,  260,  261,  262,  333,  264,  265,  381,  382,
  338,  261,  622,  341,  342,  343,  344,  257,  258,  259,
  260,  261,  262,  262,  264,  265,  257,  258,  259,  260,
  261,  262,  262,  264,  265,  382,  257,  258,  259,  260,
  261,  262,  370,  264,  265,  655,  656,  381,  382,  659,
  381,  382,  268,  668,  669,  670,  671,  672,  673,  674,
  276,  389,  278,  381,  280,  264,  265,  381,  382,  289,
  286,  287,  288,  256,  290,  381,  382,  687,  391,  392,
  393,  394,  395,  396,  397,  398,  381,  382,  304,  305,
  306,  307,  262,  313,  314,  315,  381,  382,  381,  382,
  316,  317,  712,  350,  256,  321,  322,  327,  256,  350,
  256,  331,  332,  381,  334,  381,  389,  337,  262,  377,
  378,  379,  262,  381,  256,  341,  390,  382,  286,  381,
  381,  347,  290,  291,  261,  381,  294,  377,  381,  379,
  380,  381,  300,  370,  381,  381,  377,  378,  379,  307,
  381,  369,  310,  311,  312,  381,  377,  402,  379,  380,
  381,  771,  262,  382,  262,  291,  292,  381,  381,  327,
  359,  360,  361,  362,  363,  364,  382,  335,  336,  262,
  262,  307,  382,  381,  259,  382,  344,  313,  314,  315,
  296,  297,  382,  299,  382,  301,  382,  303,  382,  259,
  382,  370,  328,  329,  259,  331,  332,  382,  278,  335,
  280,  337,  259,  262,  284,  382,  382,  287,  288,  381,
  259,  291,  259,  329,  381,  331,  332,  382,  334,  382,
  336,  381,  381,    0,  304,  305,  306,  382,  391,  392,
  393,  394,  395,  396,  397,  398,  316,  317,  381,  667,
  668,  669,  670,  671,  672,  673,  674,  675,  676,  677,
  678,  679,  680,  382,  351,  352,  353,  354,  355,  356,
  357,  358,  391,  392,  393,  394,  395,  396,  397,  398,
  382,  382,  700,  701,  702,  703,  704,  705,  382,  391,
  392,  393,  394,  395,  396,  397,  398,  391,  392,  393,
  394,  395,  396,  397,  398,  701,  702,  703,  704,  705,
  676,  677,  678,  679,  680,  259,  259,  259,  259,  382,
  382,  418,  600,  583,  587,  584,  499,  581,  585,  769,
  623,  687,  588,  582,  772,  183,  467,   -1,  586,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  591,
};
#define YYFINAL 37
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 408
#define YYUNDFTOKEN 601
#define YYTRANSLATE(a) ((a) > YYMAXTOKEN ? YYUNDFTOKEN : (a))
#if YYDEBUG
static const char *const oprs_yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"REAL_TK","POINTER_TK",
"INTEGER_TK","LONG_LONG_TK","QSTRING_TK","SYMBOL_TK","COMMENT_TK",
"LOGICAL_VAR_TK","PROGRAM_VAR_TK","HELP_TK","ADD_TK","CONCLUDE_TK","CONSULT_TK",
"DECLARE_TK","DELETE_TK","ECHO_TK","EMPTY_TK","INCLUDE_TK","LIST_TK","LOAD_TK",
"RELOAD_TK","RECEIVE_TK","RESET_TK","SEND_TK","SET_TK","SHOW_TK","STAT_TK",
"TRACE_TK","UNIFY_TK","DB_TK","FACT_TK","GOAL_TK","TSYM_TK","INTENTION_TK",
"OP_TK","OPF_TK","KERNEL_TK","CONDITION_TK","COMPLETION_TK","META_TK","EVAL_TK",
"POST_TK","PARALLEL_TK","PROFILING_TK","SILENT_TK","FRAME_TK","SOAK_TK",
"THREADING_TK","INTEND_TK","SUC_FAIL_TK","ALL_TK","ON_TK","OFF_TK","VERSION_TK",
"COPYRIGHT_TK","MEMORY_TK","FF_TK","BE_TK","CWP_TK","RELEVANT_TK",
"APPLICABLE_TK","TAKE_STDIN_TK","DISCONNECT_TK","QUIT_TK","TEXT_TK",
"GRAPHIC_TK","CALL_EXTERNAL_TK","DUMMY_TK","SAVE_TK","UNDECLARE_TK","TYPE_TK",
"EVALUABLE_TK","AC_TK","EXTERNAL_TK","PREDICATE_TK","FUNCTION_TK","REQUIRE_TK",
"SYM_TK","VARIABLE_TK","OPRS_DATA_PATH_TK","OP_PREDICATE_TK","DUMP_TK",
"MAKE_TK","WORLD_TK","STEP_TK","NEXT_TK","HALT_TK","RUN_TK","STATUS_TK",
"FAILURE_TK","USER_TK","OPF_VERSION1","OPF_VERSION2","TYPE_SEP_TK",
"FT_INVOCATION_TK","FT_CONTEXT_TK","FT_ACTION_TK","FT_CALL_TK","FT_SETTING_TK",
"FT_PROPERTIES_TK","FT_DOCUMENTATION_TK","FT_EFFECTS_TK","NT_PROCESS_TK",
"NT_START_TK","NT_END_TK","NT_ELSE_TK","NT_THEN_TK","NT_IF_TK","ET_GOAL_TK",
"ET_ELSE_TK","ET_THEN_TK","ET_IF_TK","SPEC_ACT_TK","RESET_DOT_TK","OR_TK",
"TEMP_CONCLUDE_TK","RETRACT_TK","AND_TK","COND_ADD_TK","COND_DEL_TK",
"OP_LISP_TK","CP_LISP_TK","OP_ARRAY_TK","CP_ARRAY_TK","OPENP_TK","CLOSEP_TK",
"ACHIEVE_TK","TEST_TK","PRESERVE_TK","MAINTAIN_TK","WAIT_TK","CALL_TK","EOF_TK",
"TFT_INVOCATION_TK","TFT_CONTEXT_TK","TFT_SETTING_TK","TFT_BODY_TK",
"TFT_CALL_TK","TFT_PROPERTIES_TK","TFT_DOCUMENTATION_TK","TFT_EFFECTS_TK",
"TFT_ACTION_TK","WHILE_TK","DO_TK","PAR_TK","DEFOP_TK","IF_TK","ELSE_TK",
"GOTO_TK","BREAK_TK","ELSEIF_TK","LABEL_TK",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,"illegal-symbol",
};
static const char *const oprs_yyrule[] = {
"$accept : one_command_return",
"one_command_return : command",
"one_command_return : EOF_TK",
"$$1 :",
"command : UNIFY_TK $$1 expr expr",
"$$2 :",
"$$3 :",
"command : LOAD_TK DB_TK $$2 read_file_name $$3 db_expr_list_par",
"$$4 :",
"command : LOAD_TK OP_TK $$4 top_or_nop",
"$$5 :",
"$$6 :",
"command : LOAD_TK OPF_TK $$5 read_file_name $$6 op_graph",
"$$7 :",
"$$8 :",
"command : LOAD_TK OP_TK $$7 symbol_list read_file_name $$8 op_graph",
"$$9 :",
"command : DELETE_TK OP_TK $$9 op_name",
"$$10 :",
"command : DELETE_TK OPF_TK $$10 file_name",
"$$11 :",
"$$12 :",
"command : RELOAD_TK OPF_TK $$11 read_file_name $$12 op_graph",
"$$13 :",
"command : SHOW_TK OP_TK $$13 op_name",
"command : LIST_TK OP_TK",
"command : LIST_TK VARIABLE_TK OP_TK",
"command : LIST_TK OPF_TK",
"command : LIST_TK CWP_TK",
"command : LIST_TK FF_TK",
"command : LIST_TK BE_TK",
"command : LIST_TK EVALUABLE_TK FUNCTION_TK",
"command : LIST_TK OP_PREDICATE_TK",
"command : LIST_TK EVALUABLE_TK PREDICATE_TK",
"command : LIST_TK FUNCTION_TK",
"command : LIST_TK PREDICATE_TK",
"command : LIST_TK AC_TK",
"command : LIST_TK ALL_TK",
"$$14 :",
"$$15 :",
"command : TRACE_TK GRAPHIC_TK OP_TK $$14 op_name $$15 debug_flag",
"$$16 :",
"$$17 :",
"command : TRACE_TK GRAPHIC_TK OPF_TK $$16 file_name $$17 debug_flag",
"$$18 :",
"$$19 :",
"command : TRACE_TK STEP_TK OP_TK $$18 op_name $$19 debug_flag",
"$$20 :",
"$$21 :",
"command : TRACE_TK STEP_TK OPF_TK $$20 file_name $$21 debug_flag",
"$$22 :",
"$$23 :",
"command : TRACE_TK TEXT_TK OP_TK $$22 op_name $$23 debug_flag",
"$$24 :",
"$$25 :",
"command : TRACE_TK TEXT_TK OPF_TK $$24 file_name $$25 debug_flag",
"command : SHOW_TK VARIABLE_TK",
"command : SHOW_TK DB_TK",
"command : SHOW_TK ALL_TK DB_TK",
"command : SHOW_TK INTENTION_TK",
"command : SHOW_TK CONDITION_TK",
"command : SHOW_TK RUN_TK STATUS_TK",
"command : STAT_TK DB_TK",
"command : STAT_TK SYM_TK",
"command : STAT_TK ALL_TK",
"$$26 :",
"command : SAVE_TK DB_TK $$26 write_file_name",
"$$27 :",
"command : DUMP_TK DB_TK $$27 write_file_name",
"$$28 :",
"command : DUMP_TK OP_TK $$28 write_file_name",
"command : DUMP_TK ALL_TK OPF_TK",
"$$29 :",
"command : DUMP_TK KERNEL_TK $$29 write_file_name",
"$$30 :",
"command : LOAD_TK DUMP_TK DB_TK $$30 read_file_name",
"$$31 :",
"command : LOAD_TK DUMP_TK OP_TK $$31 read_file_name",
"$$32 :",
"command : LOAD_TK DUMP_TK KERNEL_TK $$32 read_file_name",
"$$33 :",
"command : LOAD_TK EXTERNAL_TK $$33 QSTRING_TK QSTRING_TK",
"$$34 :",
"command : LOAD_TK AC_TK $$34 QSTRING_TK",
"$$35 :",
"command : LOAD_TK EVALUABLE_TK FUNCTION_TK $$35 QSTRING_TK",
"$$36 :",
"command : LOAD_TK EVALUABLE_TK PREDICATE_TK $$36 QSTRING_TK",
"command : EMPTY_TK FACT_TK DB_TK",
"command : EMPTY_TK OP_TK DB_TK",
"$$37 :",
"command : INCLUDE_TK $$37 read_file_name",
"$$38 :",
"command : REQUIRE_TK $$38 read_file_name",
"$$39 :",
"command : DECLARE_TK TYPE_TK $$39 SYMBOL_TK SYMBOL_TK",
"command : SHOW_TK TYPE_TK SYMBOL_TK",
"$$40 :",
"command : DECLARE_TK SYM_TK $$40 dec_symbol_list",
"$$41 :",
"command : DECLARE_TK TSYM_TK $$41 dec_tsymbol_list",
"$$42 :",
"command : DECLARE_TK PREDICATE_TK $$42 pred_func",
"$$43 :",
"command : DECLARE_TK FUNCTION_TK $$43 pred_func",
"$$44 :",
"command : DECLARE_TK OP_PREDICATE_TK $$44 pred_func",
"$$45 :",
"command : DECLARE_TK CWP_TK $$45 pred_func",
"$$46 :",
"command : DECLARE_TK FF_TK $$46 pred_func INTEGER_TK",
"$$47 :",
"command : DECLARE_TK BE_TK $$47 pred_func",
"$$48 :",
"command : UNDECLARE_TK BE_TK $$48 pred_func",
"$$49 :",
"command : UNDECLARE_TK OP_PREDICATE_TK $$49 pred_func",
"$$50 :",
"command : UNDECLARE_TK FUNCTION_TK $$50 pred_func",
"command : STEP_TK",
"command : NEXT_TK",
"command : HALT_TK",
"command : RUN_TK",
"command : DISCONNECT_TK",
"command : TAKE_STDIN_TK",
"command : COMPLETION_TK",
"command : RESET_TK KERNEL_TK",
"$$51 :",
"command : CONCLUDE_TK $$51 expr",
"command : CONCLUDE_TK error RESET_DOT_TK",
"$$52 :",
"command : DELETE_TK $$52 expr",
"command : DELETE_TK error RESET_DOT_TK",
"$$53 :",
"command : CONSULT_TK $$53 expr",
"command : CONSULT_TK error RESET_DOT_TK",
"command : consult_rop_frame expr",
"command : consult_aop_frame expr",
"command : RESET_TK PROFILING_TK",
"command : SHOW_TK MEMORY_TK",
"command : SHOW_TK PROFILING_TK",
"command : SHOW_TK COPYRIGHT_TK",
"command : SHOW_TK VERSION_TK",
"command : SHOW_TK OPRS_DATA_PATH_TK",
"command : SET_TK OPRS_DATA_PATH_TK QSTRING_TK",
"command : SET_TK META_TK debug_flag",
"command : SET_TK SOAK_TK debug_flag",
"command : SET_TK META_TK FACT_TK debug_flag",
"command : SET_TK META_TK GOAL_TK debug_flag",
"command : SET_TK META_TK FACT_TK OP_TK debug_flag",
"command : SET_TK META_TK GOAL_TK OP_TK debug_flag",
"command : SET_TK EVAL_TK POST_TK debug_flag",
"command : SET_TK PARALLEL_TK POST_TK debug_flag",
"command : SET_TK PARALLEL_TK INTEND_TK debug_flag",
"command : SET_TK PARALLEL_TK INTENTION_TK debug_flag",
"command : SET_TK SYM_TK debug_flag",
"command : SET_TK AC_TK debug_flag",
"command : SET_TK FUNCTION_TK debug_flag",
"command : SET_TK PREDICATE_TK debug_flag",
"command : SET_TK SILENT_TK debug_flag",
"command : TRACE_TK USER_TK TRACE_TK debug_flag",
"command : TRACE_TK USER_TK OP_TK debug_flag",
"command : TRACE_TK USER_TK INTEND_TK debug_flag",
"command : TRACE_TK USER_TK SUC_FAIL_TK debug_flag",
"command : TRACE_TK USER_TK SEND_TK debug_flag",
"command : TRACE_TK USER_TK RECEIVE_TK debug_flag",
"command : TRACE_TK USER_TK FACT_TK debug_flag",
"command : TRACE_TK USER_TK GOAL_TK debug_flag",
"command : TRACE_TK USER_TK RELEVANT_TK OP_TK debug_flag",
"command : TRACE_TK USER_TK APPLICABLE_TK OP_TK debug_flag",
"command : TRACE_TK USER_TK THREADING_TK debug_flag",
"command : TRACE_TK TEXT_TK debug_flag",
"command : TRACE_TK GRAPHIC_TK debug_flag",
"command : TRACE_TK INTEND_TK debug_flag",
"command : TRACE_TK SUC_FAIL_TK debug_flag",
"command : TRACE_TK INTENTION_TK FAILURE_TK debug_flag",
"command : TRACE_TK INTENTION_TK FAILURE_TK VARIABLE_TK debug_flag",
"command : TRACE_TK SEND_TK debug_flag",
"command : TRACE_TK RECEIVE_TK debug_flag",
"command : TRACE_TK FACT_TK debug_flag",
"command : TRACE_TK GOAL_TK debug_flag",
"command : TRACE_TK DB_TK debug_flag",
"command : TRACE_TK CONCLUDE_TK debug_flag",
"command : TRACE_TK DB_TK FRAME_TK debug_flag",
"command : TRACE_TK LOAD_TK OP_TK debug_flag",
"command : TRACE_TK RELEVANT_TK OP_TK debug_flag",
"command : TRACE_TK APPLICABLE_TK OP_TK debug_flag",
"command : TRACE_TK THREADING_TK debug_flag",
"command : TRACE_TK ALL_TK debug_flag",
"$$54 :",
"command : ECHO_TK $$54 echo_tout",
"command : ECHO_TK error RESET_DOT_TK",
"command : add_frame expr",
"$$55 :",
"command : RECEIVE_TK $$55 SYMBOL_TK expr",
"$$56 :",
"command : SEND_TK $$56 SYMBOL_TK expr",
"command : add_frame error RESET_DOT_TK",
"command : HELP_TK",
"command : CALL_EXTERNAL_TK INTEGER_TK",
"command : QUIT_TK",
"command : RESET_DOT_TK",
"command : error reset_or_eof",
"consult_rop_frame : CONSULT_TK RELEVANT_TK OP_TK",
"consult_aop_frame : CONSULT_TK APPLICABLE_TK OP_TK",
"debug_flag : ON_TK",
"debug_flag : OFF_TK",
"dec_symbol_list : SYMBOL_TK",
"dec_symbol_list : OPENP_TK symbol_list CLOSEP_TK",
"dec_tsymbol_list : SYMBOL_TK TYPE_SEP_TK SYMBOL_TK",
"dec_tsymbol_list : OPENP_TK tsymbol_list CLOSEP_TK",
"tsymbol_list :",
"tsymbol_list : tsymbol_list SYMBOL_TK TYPE_SEP_TK SYMBOL_TK",
"symbol : SYMBOL_TK",
"symbol : SYMBOL_TK TYPE_SEP_TK SYMBOL_TK",
"add_frame : ADD_TK",
"$$57 :",
"echo_tout : $$57 expr",
"db_expr_list_par : OPENP_TK db_expr_list CLOSEP_TK",
"db_expr_list_par : OPENP_TK error reset_or_eof",
"reset_or_eof : RESET_DOT_TK",
"reset_or_eof : EOF_TK",
"db_expr_list :",
"db_expr_list : db_expr_list expr",
"db_expr_list : error RESET_DOT_TK",
"$$58 :",
"op_graph : $$58 new_op_graph",
"op_graph : error EOF_TK",
"new_op_graph :",
"$$59 :",
"new_op_graph : OPENP_TK OPF_VERSION1 $$59 nop_list CLOSEP_TK",
"$$60 :",
"$$61 :",
"new_op_graph : OPENP_TK OPF_VERSION2 $$60 OPENP_TK symbol_list $$61 CLOSEP_TK nop_list CLOSEP_TK",
"$$62 :",
"new_op_graph : OPENP_TK $$62 top_list CLOSEP_TK",
"symbol_list :",
"symbol_list : symbol_list SYMBOL_TK",
"nop_list :",
"nop_list : nop_list nop",
"nop_list : nop_list top",
"top_or_nop : top",
"top_or_nop : nop",
"$$63 :",
"nop : OPENP_TK op_name $$63 OPENP_TK nlist_fields CLOSEP_TK OPENP_TK nlist_nodes CLOSEP_TK OPENP_TK nlist_edges CLOSEP_TK CLOSEP_TK",
"nlist_nodes :",
"nlist_nodes : nlist_nodes nnode",
"$$64 :",
"nnode : OPENP_TK $$64 nnode_typed CLOSEP_TK",
"$$65 :",
"nnode_typed : NT_ELSE_TK $$65 node_name join split pos_x pos_y",
"$$66 :",
"nnode_typed : NT_THEN_TK $$66 node_name join split pos_x pos_y",
"$$67 :",
"nnode_typed : NT_IF_TK $$67 node_name join split pos_x pos_y",
"$$68 :",
"nnode_typed : NT_PROCESS_TK $$68 node_name join split pos_x pos_y",
"$$69 :",
"nnode_typed : NT_END_TK $$69 node_name join split pos_x pos_y",
"$$70 :",
"nnode_typed : NT_START_TK $$70 node_name join split pos_x pos_y",
"join : boolean",
"split : boolean",
"nlist_fields :",
"nlist_fields : nlist_fields nfield",
"$$71 :",
"nfield : OPENP_TK $$71 nfield_typed CLOSEP_TK",
"$$72 :",
"nfield_typed : FT_INVOCATION_TK $$72 node_name invocation pos_x pos_y visible pp_width pp_fill",
"$$73 :",
"nfield_typed : FT_CALL_TK $$73 node_name call pos_x pos_y visible pp_width pp_fill",
"$$74 :",
"nfield_typed : FT_CONTEXT_TK $$74 node_name context pos_x pos_y visible pp_width pp_fill",
"$$75 :",
"nfield_typed : FT_SETTING_TK $$75 node_name setting pos_x pos_y visible pp_width pp_fill",
"$$76 :",
"nfield_typed : FT_PROPERTIES_TK $$76 node_name properties pos_x pos_y visible pp_width pp_fill",
"$$77 :",
"nfield_typed : FT_DOCUMENTATION_TK $$77 node_name documentation pos_x pos_y visible pp_width pp_fill",
"$$78 :",
"nfield_typed : FT_EFFECTS_TK $$78 node_name effects pos_x pos_y visible pp_width pp_fill",
"$$79 :",
"nfield_typed : FT_ACTION_TK $$79 node_name action pos_x pos_y visible pp_width pp_fill",
"pos_x : INTEGER_TK",
"pos_y : INTEGER_TK",
"visible : boolean",
"pp_width : INTEGER_TK",
"pp_fill : boolean",
"boolean : INTEGER_TK",
"$$80 :",
"invocation : $$80 expr",
"call :",
"call : expr",
"context :",
"context : expr",
"context : list_par_expr",
"setting :",
"$$81 :",
"setting : $$81 expr",
"properties :",
"$$82 :",
"properties : OPENP_TK $$82 properties_list CLOSEP_TK",
"properties_list :",
"properties_list : properties_list property",
"documentation :",
"documentation : QSTRING_TK",
"$$83 :",
"effects : $$83 list_effects",
"$$84 :",
"action : $$84 action_expr",
"$$85 :",
"action_expr : OPENP_TK SPEC_ACT_TK $$85 variable simple_action CLOSEP_TK",
"$$86 :",
"action_expr : OPENP_TK SPEC_ACT_TK $$86 OPENP_TK var_list CLOSEP_TK simple_action CLOSEP_TK",
"action_expr : simple_action",
"$$87 :",
"simple_action : OPENP_TK $$87 pred_func term_list CLOSEP_TK",
"nlist_edges :",
"nlist_edges : nlist_edges nedge",
"$$88 :",
"nedge : OPENP_TK $$88 nedge_typed CLOSEP_TK",
"nedge : error RESET_DOT_TK",
"$$89 :",
"edge_expr : $$89 expr",
"edge_knots : OPENP_TK list_knots CLOSEP_TK",
"list_knots :",
"list_knots : list_knots OPENP_TK INTEGER_TK INTEGER_TK CLOSEP_TK",
"op_name : SYMBOL_TK",
"edge_name : SYMBOL_TK",
"node_name : SYMBOL_TK",
"$$90 :",
"nedge_typed : ET_GOAL_TK $$90 node_name edge_name node_name edge_expr edge_knots pos_x pos_y pp_width pp_fill",
"$$91 :",
"nedge_typed : ET_IF_TK $$91 node_name edge_name node_name edge_expr edge_knots pos_x pos_y pp_width pp_fill",
"$$92 :",
"nedge_typed : ET_ELSE_TK $$92 node_name edge_name node_name",
"$$93 :",
"nedge_typed : ET_THEN_TK $$93 node_name edge_name node_name",
"top_list :",
"top_list : top_list top",
"top_list : error RESET_DOT_TK",
"$$94 :",
"top : OPENP_TK DEFOP_TK op_name $$94 fields_list CLOSEP_TK",
"fields_list : invocation_field other_fields_list",
"other_fields_list : field",
"other_fields_list : other_fields_list field",
"field : body_field",
"field : action_field",
"field : call_field",
"field : context_field",
"field : setting_field",
"field : properties_field",
"field : documentation_field",
"field : effects_field",
"invocation_field : TFT_INVOCATION_TK invocation",
"call_field : TFT_CALL_TK call",
"context_field : TFT_CONTEXT_TK context",
"setting_field : TFT_SETTING_TK setting",
"properties_field : TFT_PROPERTIES_TK properties",
"documentation_field : TFT_DOCUMENTATION_TK documentation",
"effects_field : TFT_EFFECTS_TK effects",
"action_field : TFT_ACTION_TK action",
"$$95 :",
"body_field : TFT_BODY_TK $$95 body",
"body : OPENP_TK list_inst CLOSEP_TK",
"list_inst :",
"list_inst : list_inst inst",
"inst : top_expr",
"inst : if_inst",
"inst : while_inst",
"inst : do_inst",
"inst : par_inst",
"inst : comment",
"inst : goto_inst",
"inst : label_inst",
"inst : break_inst",
"top_expr : expr",
"comment : COMMENT_TK",
"goto_inst : GOTO_TK SYMBOL_TK",
"break_inst : BREAK_TK",
"label_inst : LABEL_TK SYMBOL_TK",
"if_part_inst : expr list_inst",
"if_part_inst : expr list_inst ELSE_TK list_inst",
"if_part_inst : expr list_inst ELSEIF_TK if_part_inst",
"if_inst : OPENP_TK IF_TK if_part_inst CLOSEP_TK",
"while_inst : OPENP_TK WHILE_TK expr list_inst CLOSEP_TK",
"do_inst : OPENP_TK DO_TK list_inst WHILE_TK expr CLOSEP_TK",
"par_inst : OPENP_TK PAR_TK body_list CLOSEP_TK",
"body_list :",
"body_list : body_list body",
"variable : LOGICAL_VAR_TK",
"variable : LOGICAL_VAR_TK TYPE_SEP_TK SYMBOL_TK",
"variable : PROGRAM_VAR_TK",
"variable : PROGRAM_VAR_TK TYPE_SEP_TK SYMBOL_TK",
"list_effects :",
"list_effects : list_par_expr",
"list_par_expr : OPENP_TK list_expr CLOSEP_TK",
"list_par_expr : OPENP_TK CLOSEP_TK",
"list_expr : expr",
"list_expr : list_expr expr",
"expr : OPENP_TK pred_func term_list CLOSEP_TK",
"expr : OPENP_TK pred_func error CLOSEP_TK",
"pred_func : variable",
"pred_func : SYMBOL_TK",
"term_list :",
"term_list : term_list term",
"file_name : QSTRING_TK",
"term : INTEGER_TK",
"term : LONG_LONG_TK",
"term : POINTER_TK",
"term : REAL_TK",
"term : QSTRING_TK",
"term : symbol",
"term : variable",
"term : expr",
"term : OP_LISP_TK term_list CP_LISP_TK",
"term : OP_ARRAY_TK term_list CP_ARRAY_TK",
"term : OP_ARRAY_TK error CP_ARRAY_TK",
"term : OP_ARRAY_TK error CLOSEP_TK",
"term : OP_ARRAY_TK error CP_LISP_TK",
"term : OPENP_TK error CLOSEP_TK",
"term : OPENP_TK error CP_LISP_TK",
"term : OPENP_TK error CP_ARRAY_TK",
"term : OP_LISP_TK error CP_LISP_TK",
"term : OP_LISP_TK error CLOSEP_TK",
"term : OP_LISP_TK error CP_ARRAY_TK",
"var_list : variable",
"var_list : var_list variable",
"property : OPENP_TK prop_name term CLOSEP_TK",
"property : OPENP_TK prop_name error CLOSEP_TK",
"property : OPENP_TK error CLOSEP_TK",
"prop_name : SYMBOL_TK",
"read_file_name : QSTRING_TK",
"write_file_name : QSTRING_TK",

};
#endif

int      yydebug;
int      yynerrs;

int      yyerrflag;
int      yychar;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH  10000
#endif
#endif

#define YYINITSTACKSIZE 200

typedef struct {
    unsigned stacksize;
    YYINT    *s_base;
    YYINT    *s_mark;
    YYINT    *s_last;
    YYSTYPE  *l_base;
    YYSTYPE  *l_mark;
} YYSTACKDATA;
/* variables for the parser stack */
static YYSTACKDATA yystack;
#line 1394 "oprs-parser.y"

PBoolean loaded_include_file(char *filename)
{
	 return (current_oprs->included_file_name ?
	     (sl_search_slist(current_oprs->included_file_name, filename, equal_string) != NULL) :
	     FALSE);
}

void provide_include_file(char *filename)
{
  if (! current_oprs->included_file_name)  
    current_oprs->included_file_name = sl_make_slist();
  
  sl_add_to_tail(current_oprs->included_file_name,filename);
}
#line 1512 "oprs-parser.c"

#if YYDEBUG
#include <stdio.h>	/* needed for printf */
#endif

#include <stdlib.h>	/* needed for malloc, etc */
#include <string.h>	/* needed for memset */

/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(YYSTACKDATA *data)
{
    int i;
    unsigned newsize;
    YYINT *newss;
    YYSTYPE *newvs;

    if ((newsize = data->stacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return YYENOMEM;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = (int) (data->s_mark - data->s_base);
    newss = (YYINT *)realloc(data->s_base, newsize * sizeof(*newss));
    if (newss == 0)
        return YYENOMEM;

    data->s_base = newss;
    data->s_mark = newss + i;

    newvs = (YYSTYPE *)realloc(data->l_base, newsize * sizeof(*newvs));
    if (newvs == 0)
        return YYENOMEM;

    data->l_base = newvs;
    data->l_mark = newvs + i;

    data->stacksize = newsize;
    data->s_last = data->s_base + newsize - 1;
    return 0;
}

#if YYPURE || defined(YY_NO_LEAKS)
static void yyfreestack(YYSTACKDATA *data)
{
    free(data->s_base);
    free(data->l_base);
    memset(data, 0, sizeof(*data));
}
#else
#define yyfreestack(data) /* nothing */
#endif

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yym = 0;
    yyn = 0;
    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

#if YYPURE
    memset(&yystack, 0, sizeof(yystack));
#endif

    if (yystack.s_base == NULL && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    yystack.s_mark = yystack.s_base;
    yystack.l_mark = yystack.l_base;
    yystate = 0;
    *yystack.s_mark = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        yychar = YYLEX;
        if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if (((yyn = yysindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
        yystate = yytable[yyn];
        *++yystack.s_mark = yytable[yyn];
        *++yystack.l_mark = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if (((yyn = yyrindex[yystate]) != 0) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag != 0) goto yyinrecovery;

    YYERROR_CALL("syntax error");

    goto yyerrlab; /* redundant goto avoids 'unused label' warning */
yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if (((yyn = yysindex[*yystack.s_mark]) != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yystack.s_mark, yytable[yyn]);
#endif
                if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
                yystate = yytable[yyn];
                *++yystack.s_mark = yytable[yyn];
                *++yystack.l_mark = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yystack.s_mark);
#endif
                if (yystack.s_mark <= yystack.s_base) goto yyabort;
                --yystack.s_mark;
                --yystack.l_mark;
            }
        }
    }
    else
    {
        if (yychar == YYEOF) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym > 0)
        yyval = yystack.l_mark[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);

    switch (yyn)
    {
case 1:
#line 178 "oprs-parser.y"
	{YYACCEPT;}
break;
case 2:
#line 179 "oprs-parser.y"
	{YYACCEPT;}
break;
case 3:
#line 183 "oprs-parser.y"
	{enable_variable_parsing();  yy_begin_0();}
break;
case 4:
#line 185 "oprs-parser.y"
	{test_unify_expr(yystack.l_mark[-1].expr,yystack.l_mark[0].expr); disable_variable_parsing(); 
						 free_expr(yystack.l_mark[-1].expr); free_expr(yystack.l_mark[0].expr);}
break;
case 5:
#line 188 "oprs-parser.y"
	{yy_begin_0();}
break;
case 6:
#line 189 "oprs-parser.y"
	{printf(LG_STR("%sLoading DB \"%s\".\n",
							       "%sChargement base de faits \"%s\".\n"),parser_indent, yystack.l_mark[0].string); 
						 if (open_file_for_yyparse(yystack.l_mark[0].string)<0) {
						      printf(LG_STR("%sAbort Loading DB.\n",
								    "%sAbandon chargement base de faits.\n"),parser_indent);
						      FREE(yystack.l_mark[0].string);
						      YYABORT; 
						 } 
						 FREE(yystack.l_mark[0].string);}
break;
case 7:
#line 198 "oprs-parser.y"
	{close_file_for_yyparse(); recheck_all_conditions();
						 printf(LG_STR("%sLoading DB done.\n",
							       "%sChargement base de faits termin.\n"),parser_indent);}
break;
case 8:
#line 201 "oprs-parser.y"
	{yy_begin_0(); current_graph_file_name = "stdin";}
break;
case 10:
#line 203 "oprs-parser.y"
	{yy_begin_0();}
break;
case 11:
#line 204 "oprs-parser.y"
	{char *dopf_filename;
		                                 if ((dopf_filename = read_file_name_newer_dopf_p(yystack.l_mark[0].string))) {
		                                 printf(LG_STR("%sLoading compiled OPs from \"%s\".\n",
							       "%sChargement OPs compils de \"%s\".\n"),parser_indent,dopf_filename);
		                                 load_op_database_from_parser(current_oprs->relevant_op, dopf_filename);
						 printf(LG_STR("\n%sLoading compiled OPs done.\n",
							       "\n%sChargement OPs compils termin.\n"),parser_indent);
						 FREE(dopf_filename);
						 FREE(yystack.l_mark[0].string);
						 YYACCEPT;}
                                                 if ( !dev_env ) {
						      printf(LG_STR("This command is only available on OPRS Development version.\n",
								    "Cette commande n'est disponible que sur les versions de Dveloppement de OPRS."));
						      FREE(yystack.l_mark[0].string);
						      YYABORT;
						 }
                                                 if (!be_quiet) printf(LG_STR("%sLoading/Compiling OP File \"%s\".\n",
									      "%sChargement/Compilation fichier OP \"%s\".\n"),parser_indent, yystack.l_mark[0].string);
						 if (open_file_for_yyparse(yystack.l_mark[0].string)<0) {
						      printf(LG_STR("%sAbort loading/compiling OP File.\n",
								    "%sAbandon chargement/compilation fichier OP.\n"),parser_indent);
						      FREE(yystack.l_mark[0].string);
						      YYABORT;
						 }
						 load_op_list = NULL; current_graph_file_name = yystack.l_mark[0].string;}
break;
case 12:
#line 229 "oprs-parser.y"
	{close_file_for_yyparse(); FREE(yystack.l_mark[-2].string);
						 if (!be_quiet) printf(LG_STR("%sLoading/Compiling OP File done.\n",
									      "%sChargement/Compilation fichier OP termin.\n"),parser_indent);}
break;
case 13:
#line 232 "oprs-parser.y"
	{yy_begin_0();}
break;
case 14:
#line 233 "oprs-parser.y"
	{ if ( !dev_env ) {
						      printf(LG_STR("This command is only available on OPRS Development version.\n",
								    "Cette commande n'est disponible que sur les versions de Dveloppement de OPRS."));
						      FREE(yystack.l_mark[0].string);
						      FREE_SLIST(yystack.l_mark[-1].list);
						      YYABORT;
						 }
                                                 if (!be_quiet) printf(LG_STR("%sLoading/Compiling some OPs from OP File \"%s\".\n",
									      "%sChargement/Compilation d'OPs du fichier OP \"%s\".\n"),parser_indent, yystack.l_mark[0].string);
						 if (open_file_for_yyparse(yystack.l_mark[0].string)<0) {
						      printf(LG_STR("%sAbort loading/compiling  some OPs fromOP File.\n",
								    "%sAbandon chargement/compilation d'OPs du fichier OP.\n"),parser_indent);
						      FREE(yystack.l_mark[0].string);
						      YYABORT;
						 }
						 load_op_list = yystack.l_mark[-1].list; current_graph_file_name = yystack.l_mark[0].string;}
break;
case 15:
#line 249 "oprs-parser.y"
	{close_file_for_yyparse(); FREE(yystack.l_mark[-2].string); FREE_SLIST(yystack.l_mark[-3].list);
						 if (!be_quiet) printf(LG_STR("%sLoading/Compiling some OPs from OP File done.\n",
									      "%sChargement/Compilation d'OPs du fichier OP termin.\n"),parser_indent);}
break;
case 16:
#line 252 "oprs-parser.y"
	{yy_begin_0();}
break;
case 17:
#line 253 "oprs-parser.y"
	{delete_op_name_from_rop(yystack.l_mark[0].string,current_oprs->relevant_op,
#ifndef GRAPHIX
									 FALSE
#else
									 (global_draw_data?TRUE:FALSE)
#endif
									 );}
break;
case 18:
#line 260 "oprs-parser.y"
	{yy_begin_0();}
break;
case 19:
#line 261 "oprs-parser.y"
	{delete_opf_from_rop(yystack.l_mark[0].string,current_oprs->relevant_op,
#ifndef GRAPHIX
								     FALSE
#else
								     (global_draw_data?TRUE:FALSE)
#endif
								     , TRUE);FREE(yystack.l_mark[0].string);}
break;
case 20:
#line 268 "oprs-parser.y"
	{yy_begin_0();}
break;
case 21:
#line 269 "oprs-parser.y"
	{char *dopf_filename;
		                                 text = sl_make_slist();
						 graphic = sl_make_slist();
						 step_list = sl_make_slist();

						 store_trace_status(yystack.l_mark[0].string,current_oprs->relevant_op, &text, &graphic, &step_list);
						 delete_opf_from_rop(yystack.l_mark[0].string,current_oprs->relevant_op,
#ifndef GRAPHIX
								     FALSE
#else
								     (global_draw_data?TRUE:FALSE)
#endif
								     , TRUE);
                                                 if ((dopf_filename = read_file_name_newer_dopf_p(yystack.l_mark[0].string))) {
		                                    if (!be_quiet) printf(LG_STR("%sReloading compiled OPs from \"%s\".\n",
							                         "%sRechargement OPs compils de \"%s\".\n"),
									  parser_indent,
									  dopf_filename);
		                                    load_op_database_from_parser(current_oprs->relevant_op, dopf_filename);
						    if (!be_quiet) printf(LG_STR("\n%sReloading compiled OPs done.\n",
						   	                         "\n%sRechargement OPs compils termin.\n"),parser_indent);
						    restore_trace_status(yystack.l_mark[0].string,current_oprs->relevant_op, text, graphic, step_list);
						    FREE_SLIST(text);
						    FREE_SLIST(step_list);
						    FREE_SLIST(graphic);
						    FREE(dopf_filename);
						    FREE(yystack.l_mark[0].string);
						    YYACCEPT;}
                                                 if ( !dev_env ) {
						    printf(LG_STR("This command is only available on OPRS Development version.\n",
							          "Cette commande n'est disponible que sur les versions de Dveloppement de OPRS."));
						    FREE_SLIST(text);
						    FREE_SLIST(step_list);
						    FREE_SLIST(graphic);
						    FREE(yystack.l_mark[0].string);
						    YYABORT;
						 }
						 if (!be_quiet) printf(LG_STR("%sReloading/recompiling OP File \"%s\".\n",
									      "%sRechargement/recompilation fichier OP \"%s\".\n"),parser_indent, yystack.l_mark[0].string);
						 if (open_file_for_yyparse(yystack.l_mark[0].string)<0) {
						      printf(LG_STR("%sAbort reloading/recompiling OP File.\n",
								    "%sAbandon rechargement/recompilation fichier OP.\n"),parser_indent);
						      FREE(yystack.l_mark[0].string);
						      YYABORT;
						 }
						 load_op_list = NULL; current_graph_file_name = yystack.l_mark[0].string;}
break;
case 22:
#line 315 "oprs-parser.y"
	{close_file_for_yyparse();
						 if (!be_quiet) printf(LG_STR("%sReloading/recompiling OP file done.\n",
									      "%sRechargement/recompilation fichier OP termin.\n"),parser_indent);
						 restore_trace_status(yystack.l_mark[-2].string,current_oprs->relevant_op, text, graphic, step_list);
						 FREE_SLIST(text);
						 FREE_SLIST(step_list);
						 FREE_SLIST(graphic);
						 FREE(yystack.l_mark[-2].string);}
break;
case 23:
#line 323 "oprs-parser.y"
	{yy_begin_0();}
break;
case 24:
#line 324 "oprs-parser.y"
	{print_op_from_rop(yystack.l_mark[0].string,current_oprs->relevant_op);}
break;
case 25:
#line 325 "oprs-parser.y"
	{list_ops(current_oprs->relevant_op);}
break;
case 26:
#line 326 "oprs-parser.y"
	{list_ops_variables(current_oprs->relevant_op);}
break;
case 27:
#line 327 "oprs-parser.y"
	{list_opfs(current_oprs->relevant_op);}
break;
case 28:
#line 328 "oprs-parser.y"
	{list_cwp();}
break;
case 29:
#line 329 "oprs-parser.y"
	{list_ff();}
break;
case 30:
#line 330 "oprs-parser.y"
	{list_be();}
break;
case 31:
#line 331 "oprs-parser.y"
	{list_ef();}
break;
case 32:
#line 332 "oprs-parser.y"
	{list_op_predicate();}
break;
case 33:
#line 333 "oprs-parser.y"
	{list_ep();}
break;
case 34:
#line 334 "oprs-parser.y"
	{list_function();}
break;
case 35:
#line 335 "oprs-parser.y"
	{list_predicate();}
break;
case 36:
#line 336 "oprs-parser.y"
	{list_ac();}
break;
case 37:
#line 337 "oprs-parser.y"
	{list_predicate();list_cwp(); 
						 list_ff(); 
						 list_be(); 
						 list_op_predicate(); 
						 list_ep(); 
						 list_function(); list_ef(); 
						 list_ac();}
break;
case 38:
#line 344 "oprs-parser.y"
	{yy_begin_0();}
break;
case 39:
#line 345 "oprs-parser.y"
	{yy_begin_COMMAND();}
break;
case 40:
#line 346 "oprs-parser.y"
	{trace_graphic_op(yystack.l_mark[-2].string,current_oprs->relevant_op,yystack.l_mark[0].bool);}
break;
case 41:
#line 347 "oprs-parser.y"
	{yy_begin_0();}
break;
case 42:
#line 348 "oprs-parser.y"
	{yy_begin_COMMAND();}
break;
case 43:
#line 349 "oprs-parser.y"
	{trace_graphic_opf(yystack.l_mark[-2].string,current_oprs->relevant_op,yystack.l_mark[0].bool);FREE(yystack.l_mark[-2].string);}
break;
case 44:
#line 350 "oprs-parser.y"
	{yy_begin_0();}
break;
case 45:
#line 351 "oprs-parser.y"
	{yy_begin_COMMAND();}
break;
case 46:
#line 352 "oprs-parser.y"
	{trace_step_op(yystack.l_mark[-2].string,current_oprs->relevant_op,yystack.l_mark[0].bool);}
break;
case 47:
#line 353 "oprs-parser.y"
	{yy_begin_0();}
break;
case 48:
#line 354 "oprs-parser.y"
	{yy_begin_COMMAND();}
break;
case 49:
#line 355 "oprs-parser.y"
	{trace_step_opf(yystack.l_mark[-2].string,current_oprs->relevant_op,yystack.l_mark[0].bool);FREE(yystack.l_mark[-2].string);}
break;
case 50:
#line 356 "oprs-parser.y"
	{yy_begin_0();}
break;
case 51:
#line 357 "oprs-parser.y"
	{yy_begin_COMMAND();}
break;
case 52:
#line 358 "oprs-parser.y"
	{trace_text_op(yystack.l_mark[-2].string,current_oprs->relevant_op,yystack.l_mark[0].bool);}
break;
case 53:
#line 359 "oprs-parser.y"
	{yy_begin_0();}
break;
case 54:
#line 360 "oprs-parser.y"
	{yy_begin_COMMAND();}
break;
case 55:
#line 361 "oprs-parser.y"
	{trace_text_opf(yystack.l_mark[-2].string,current_oprs->relevant_op,yystack.l_mark[0].bool);FREE(yystack.l_mark[-2].string);}
break;
case 56:
#line 362 "oprs-parser.y"
	{show_global_variable();}
break;
case 57:
#line 363 "oprs-parser.y"
	{print_database(current_oprs->database);}
break;
case 58:
#line 364 "oprs-parser.y"
	{print_database_key(current_oprs->database);}
break;
case 59:
#line 365 "oprs-parser.y"
	{show_intentions(current_oprs->intention_graph);}
break;
case 60:
#line 366 "oprs-parser.y"
	{show_conditions(current_oprs->conditions_list);}
break;
case 61:
#line 367 "oprs-parser.y"
	{report_run_status();}
break;
case 62:
#line 368 "oprs-parser.y"
	{stat_database(current_oprs->database);}
break;
case 63:
#line 369 "oprs-parser.y"
	{stat_id_hashtable();}
break;
case 64:
#line 370 "oprs-parser.y"
	{stat_id_hashtable();
						 stat_database(current_oprs->database);
						 stat_pred_func_hashtable();
						 stat_type_hashtable();}
break;
case 65:
#line 374 "oprs-parser.y"
	{yy_begin_0();}
break;
case 66:
#line 375 "oprs-parser.y"
	{save_database(current_oprs->database, yystack.l_mark[0].string); FREE(yystack.l_mark[0].string);}
break;
case 67:
#line 376 "oprs-parser.y"
	{yy_begin_0();}
break;
case 68:
#line 377 "oprs-parser.y"
	{if ( !dev_env ) {
						      printf(LG_STR("This command is only available on OPRS Development version.\n",
								    "Cette commande n'est disponible que sur les versions de Dveloppement de OPRS."));
						      FREE(yystack.l_mark[0].string);
						      YYABORT;
						 }
                                                 printf(LG_STR("Dumping fact db in \"%s\".\n",
							       "Dump de base de faits dans \"%s\".\n"),yystack.l_mark[0].string);
		                                 dump_database_from_parser(current_oprs->database, yystack.l_mark[0].string);
						 printf(LG_STR("\nDumping DB done.\n",
							       "\nDump base de faits termin.\n"));
						 FREE(yystack.l_mark[0].string);}
break;
case 69:
#line 389 "oprs-parser.y"
	{yy_begin_0();}
break;
case 70:
#line 390 "oprs-parser.y"
	{if ( !dev_env ) {
						      printf(LG_STR("This command is only available on OPRS Development version.\n",
								    "Cette commande n'est disponible que sur les versions de Dveloppement de OPRS."));
						      FREE(yystack.l_mark[0].string);
						      YYABORT;
						 }
                                                 printf(LG_STR("Dumping OP db in \"%s\".\n",
							       "Dump de base de OP dans \"%s\".\n"),yystack.l_mark[0].string);
		                                 dump_op_database_from_parser(current_oprs->relevant_op, yystack.l_mark[0].string);
						 printf(LG_STR("\nDumping OP db done.\n",
							       "\nDump de base de OP termin.\n"));
						 FREE(yystack.l_mark[0].string);}
break;
case 71:
#line 402 "oprs-parser.y"
	{if ( !dev_env ) {
						      printf(LG_STR("This command is only available on OPRS Development version.\n",
								    "Cette commande n'est disponible que sur les versions de Dveloppement de OPRS."));
						      YYABORT;
						 } else {
						      printf(LG_STR("Dumping all OP files.\n",
								    "Dump de tous les fichiers OPs\n"));
						      dump_all_opfs(current_oprs->relevant_op);
						      printf(LG_STR("Dumping all OP files done.\n",
								    "Dump de tous les fichiers OPs termin.\n"));
						 }
                                                }
break;
case 72:
#line 414 "oprs-parser.y"
	{yy_begin_0();}
break;
case 73:
#line 415 "oprs-parser.y"
	{printf(LG_STR("Dumping kernel in \"%s\".\n",
							       "Dump du noyau dans \"%s\".\n"),yystack.l_mark[0].string);
		                                 dump_kernel_from_parser(current_oprs, yystack.l_mark[0].string);
						 printf(LG_STR("\nDumping kernel done.\n",
							       "\nDump noyau termin.\n"));
						 FREE(yystack.l_mark[0].string);}
break;
case 74:
#line 421 "oprs-parser.y"
	{yy_begin_0();}
break;
case 75:
#line 422 "oprs-parser.y"
	{printf(LG_STR("%sLoading fact db dump from \"%s\".\n",
							       "%sChargement dump base de faits de \"%s\".\n"),parser_indent,yystack.l_mark[0].string);
		                                 load_database_from_parser(current_oprs->database, yystack.l_mark[0].string);
						 printf(LG_STR("\n%sLoading db dump done.\n",
							       "\n%sChargement dump base de faits termin.\n"),parser_indent);
						 FREE(yystack.l_mark[0].string);}
break;
case 76:
#line 428 "oprs-parser.y"
	{yy_begin_0();}
break;
case 77:
#line 429 "oprs-parser.y"
	{printf(LG_STR("%sLoading OP db dump from \"%s\".\n",
							       "%sChargement dump base de OP de \"%s\".\n"),parser_indent,yystack.l_mark[0].string);
		                                 load_op_database_from_parser(current_oprs->relevant_op, yystack.l_mark[0].string);
						 printf(LG_STR("\n%sLoading OP db dump done.\n",
							       "\n%sTermin chargement dump base de OP.\n"),parser_indent);
						 FREE(yystack.l_mark[0].string);}
break;
case 78:
#line 435 "oprs-parser.y"
	{yy_begin_0();}
break;
case 79:
#line 436 "oprs-parser.y"
	{printf(LG_STR("%sLoading kenel dump from \"%s\".\n",
							       "%sChargement dump noyau OP de \"%s\".\n"),parser_indent,yystack.l_mark[0].string);
		                                 load_kernel_from_parser(current_oprs, yystack.l_mark[0].string);
						 printf(LG_STR("\n%sLoading kernel dump done.\n",
							       "\n%sChargement noyau termin.\n"),parser_indent);
						 FREE(yystack.l_mark[0].string);}
break;
case 80:
#line 442 "oprs-parser.y"
	{yy_begin_0();}
break;
case 81:
#line 443 "oprs-parser.y"
	{printf(LG_STR("%sLoading external code from dl: \"%s\", sym: %s.\n",
							       "%sChargement de code externe de la dl: \"%s\", sym: %s.\n"),parser_indent,yystack.l_mark[-1].string,yystack.l_mark[0].string);
						 load_ok = load_function_from_dl(yystack.l_mark[-1].string, yystack.l_mark[0].string);
						 printf(LG_STR("%sFinish loading external code: %s.\n",
							       "%sFin chargement code externe: %s.\n"), 
							       parser_indent,(load_ok?"SUCCESS":"FAILURE"));
						 FREE(yystack.l_mark[-1].string); FREE(yystack.l_mark[0].string);}
break;
case 82:
#line 450 "oprs-parser.y"
	{yy_begin_0();}
break;
case 83:
#line 451 "oprs-parser.y"
	{printf(LG_STR("%sLoading action(s) from dl: \"%s\".\n",
							       "%sChargement d'actions de la dl: \"%s\".\n"),parser_indent,yystack.l_mark[0].string);
						 load_function_from_dl(yystack.l_mark[0].string, "declare_user_action");
						 FREE(yystack.l_mark[0].string);}
break;
case 84:
#line 455 "oprs-parser.y"
	{yy_begin_0();}
break;
case 85:
#line 456 "oprs-parser.y"
	{printf(LG_STR("%sLoading evaluable function(s) from dl: \"%s\".\n",
							       "%sChargement de fonctions evaluables de la dl: \"%s\".\n"),parser_indent,yystack.l_mark[0].string);
						 load_function_from_dl(yystack.l_mark[0].string, "declare_user_eval_funct");
						 FREE(yystack.l_mark[0].string);}
break;
case 86:
#line 460 "oprs-parser.y"
	{yy_begin_0();}
break;
case 87:
#line 461 "oprs-parser.y"
	{printf(LG_STR("%sLoading evaluable predicates from dl: \"%s\".\n",
							       "%sChargement de predicats evaluables de la dl: \"%s\".\n"),parser_indent,yystack.l_mark[0].string);
						 load_function_from_dl(yystack.l_mark[0].string, "declare_user_eval_pred");
						 FREE(yystack.l_mark[0].string);}
break;
case 88:
#line 465 "oprs-parser.y"
	{clear_database(current_oprs->database);
						 if (!be_quiet) printf(LG_STR("Database cleared.\n",
									      "Base de faits vide.\n"));}
break;
case 89:
#line 468 "oprs-parser.y"
	{clear_op_database(current_oprs->relevant_op,
#ifndef GRAPHIX
								   FALSE
#else
								   TRUE
#endif
								   ); 
						 if (!be_quiet) printf(LG_STR("OP Database cleared.\n",
									      "Base de OP vide.\n"));}
break;
case 90:
#line 477 "oprs-parser.y"
	{yy_begin_0();}
break;
case 91:
#line 478 "oprs-parser.y"
	{if (open_file_for_yyparse(yystack.l_mark[0].string)<0) YYABORT; FREE(yystack.l_mark[0].string);}
break;
case 92:
#line 479 "oprs-parser.y"
	{yy_begin_0();}
break;
case 93:
#line 480 "oprs-parser.y"
	{if (! (loaded_include_file(yystack.l_mark[0].string))) {
		     					if (open_file_for_yyparse(yystack.l_mark[0].string)<0) YYABORT;
							provide_include_file(yystack.l_mark[0].string);
						} else  FREE(yystack.l_mark[0].string);}
break;
case 94:
#line 484 "oprs-parser.y"
	{yy_begin_0();}
break;
case 95:
#line 485 "oprs-parser.y"
	{if (yystack.l_mark[0].string== nil_sym) make_and_print_type(yystack.l_mark[-1].string, NULL); else make_and_print_type(yystack.l_mark[-1].string, yystack.l_mark[0].string);}
break;
case 96:
#line 486 "oprs-parser.y"
	{show_type(yystack.l_mark[0].string);}
break;
case 97:
#line 487 "oprs-parser.y"
	{yy_begin_0();}
break;
case 99:
#line 489 "oprs-parser.y"
	{yy_begin_0();}
break;
case 101:
#line 491 "oprs-parser.y"
	{yy_begin_0(); check_pfr = FALSE;}
break;
case 102:
#line 492 "oprs-parser.y"
	{check_pfr = TRUE;}
break;
case 103:
#line 493 "oprs-parser.y"
	{yy_begin_0(); check_pfr = FALSE;}
break;
case 104:
#line 494 "oprs-parser.y"
	{check_pfr = TRUE;}
break;
case 105:
#line 495 "oprs-parser.y"
	{yy_begin_0(); check_pfr = FALSE;}
break;
case 106:
#line 496 "oprs-parser.y"
	{declare_predicate_op(yystack.l_mark[0].pred_func_rec); check_pfr = TRUE;}
break;
case 107:
#line 497 "oprs-parser.y"
	{yy_begin_0(); check_pfr = FALSE;}
break;
case 108:
#line 498 "oprs-parser.y"
	{declare_cwp(yystack.l_mark[0].pred_func_rec); check_pfr = TRUE;}
break;
case 109:
#line 499 "oprs-parser.y"
	{yy_begin_0(); check_pfr = FALSE;}
break;
case 110:
#line 500 "oprs-parser.y"
	{declare_ff(yystack.l_mark[-1].pred_func_rec,yystack.l_mark[0].integer); check_pfr = TRUE;}
break;
case 111:
#line 501 "oprs-parser.y"
	{yy_begin_0(); check_pfr = FALSE;}
break;
case 112:
#line 502 "oprs-parser.y"
	{declare_be(yystack.l_mark[0].pred_func_rec); check_pfr = TRUE;}
break;
case 113:
#line 503 "oprs-parser.y"
	{yy_begin_0();}
break;
case 114:
#line 504 "oprs-parser.y"
	{un_declare_be(yystack.l_mark[0].pred_func_rec);}
break;
case 115:
#line 505 "oprs-parser.y"
	{yy_begin_0();}
break;
case 116:
#line 506 "oprs-parser.y"
	{un_declare_predicate_op(yystack.l_mark[0].pred_func_rec);}
break;
case 117:
#line 507 "oprs-parser.y"
	{yy_begin_0();}
break;
case 118:
#line 508 "oprs-parser.y"
	{un_declare_func(yystack.l_mark[0].pred_func_rec);}
break;
case 119:
#line 509 "oprs-parser.y"
	{set_oprs_run_mode(STEP);}
break;
case 120:
#line 510 "oprs-parser.y"
	{set_oprs_run_mode(STEP_NEXT);}
break;
case 121:
#line 511 "oprs-parser.y"
	{set_oprs_run_mode(HALT);}
break;
case 122:
#line 512 "oprs-parser.y"
	{set_oprs_run_mode(RUN);}
break;
case 123:
#line 513 "oprs-parser.y"
	{leave_the_stdin();}
break;
case 124:
#line 514 "oprs-parser.y"
	{take_the_stdin();}
break;
case 125:
#line 515 "oprs-parser.y"
	{send_completion_to_server(current_oprs->relevant_op);}
break;
case 126:
#line 516 "oprs-parser.y"
	{reset_oprs_kernel(current_oprs);}
break;
case 127:
#line 517 "oprs-parser.y"
	{yy_begin_0(); check_pfr = FALSE;}
break;
case 128:
#line 518 "oprs-parser.y"
	{parser_conclude(yystack.l_mark[0].expr,current_oprs->database); free_expr(yystack.l_mark[0].expr);
		 				 check_pfr = TRUE;}
break;
case 129:
#line 520 "oprs-parser.y"
	{warning(LG_STR("Parsing error, expecting an expr after conclude",
								"Erreur de parsing, attendait une expr aprs la commande conclude"));}
break;
case 130:
#line 522 "oprs-parser.y"
	{yy_begin_0(); enable_variable_parsing();}
break;
case 131:
#line 523 "oprs-parser.y"
	{delete_expr(yystack.l_mark[0].expr,current_oprs->database);
						 disable_variable_parsing(); free_expr(yystack.l_mark[0].expr);}
break;
case 132:
#line 525 "oprs-parser.y"
	{warning(LG_STR("Parsing error, expecting an expr after delete",
								"Erreur de parsing, attendait une expr aprs la commande delete"));}
break;
case 133:
#line 527 "oprs-parser.y"
	{yy_begin_0(); enable_variable_parsing();
						 check_pfr = FALSE;}
break;
case 134:
#line 529 "oprs-parser.y"
	{parser_consult(yystack.l_mark[0].expr,current_oprs->database);
						 check_pfr = TRUE;
					         disable_variable_parsing(); free_expr(yystack.l_mark[0].expr);}
break;
case 135:
#line 532 "oprs-parser.y"
	{warning(LG_STR("Parsing error, expecting an expr after consult",
								"Erreur de parsing, attendait une expr aprs la commande consult"));}
break;
case 136:
#line 534 "oprs-parser.y"
	{parser_consult_expr_relevant_op(yystack.l_mark[0].expr,current_oprs->relevant_op);
					         disable_variable_parsing(); free_expr(yystack.l_mark[0].expr);}
break;
case 137:
#line 536 "oprs-parser.y"
	{test_find_soak_expr(yystack.l_mark[0].expr,current_oprs);
					         disable_variable_parsing(); free_expr(yystack.l_mark[0].expr);}
break;
case 138:
#line 538 "oprs-parser.y"
	{reset_profiled_data();}
break;
case 139:
#line 539 "oprs-parser.y"
	{pmstats();}
break;
case 140:
#line 540 "oprs-parser.y"
	{report_profiled_data();}
break;
case 141:
#line 541 "oprs-parser.y"
	{print_copyright_notice();}
break;
case 142:
#line 542 "oprs-parser.y"
	{print_version();}
break;
case 143:
#line 543 "oprs-parser.y"
	{if (oprs_data_path && oprs_data_path[0])
	                                              printf(LG_STR("The current OPRS_DATA_PATH is: \"%s\"\n",
								    "Le OPRS_DATA_PATH est: \"%s\"\n"), oprs_data_path);
						 else printf(LG_STR("OPRS_DATA_PATH is not set.\n",
								    "OPRS_DATA_PATH n'a pas de valeur.\n"));}
break;
case 144:
#line 548 "oprs-parser.y"
	{oprs_data_path = replace_env_string(yystack.l_mark[0].string); FREE(yystack.l_mark[0].string);
                                                 if (!be_quiet) printf(LG_STR("Setting OPRS_DATA_PATH to: \"%s\".\n",
									      "Affectation d'OPRS_DATA_PATH a: \"%s\".\n"), oprs_data_path);}
break;
case 145:
#line 552 "oprs-parser.y"
	{meta_option[META_LEVEL]=yystack.l_mark[0].bool; report_meta_option_array();}
break;
case 146:
#line 553 "oprs-parser.y"
	{meta_option[SOAK_MF]=yystack.l_mark[0].bool; report_meta_option_array();}
break;
case 147:
#line 554 "oprs-parser.y"
	{meta_option[FACT_INV]=yystack.l_mark[0].bool; report_meta_option_array();}
break;
case 148:
#line 555 "oprs-parser.y"
	{meta_option[GOAL_INV]=yystack.l_mark[0].bool; report_meta_option_array();}
break;
case 149:
#line 556 "oprs-parser.y"
	{meta_option[APP_OPS_FACT]=yystack.l_mark[0].bool; report_meta_option_array();}
break;
case 150:
#line 557 "oprs-parser.y"
	{meta_option[APP_OPS_GOAL]=yystack.l_mark[0].bool; report_meta_option_array();}
break;
case 151:
#line 558 "oprs-parser.y"
	{run_option[EVAL_ON_POST]=yystack.l_mark[0].bool;}
break;
case 152:
#line 559 "oprs-parser.y"
	{run_option[PAR_POST]=yystack.l_mark[0].bool;}
break;
case 153:
#line 560 "oprs-parser.y"
	{run_option[PAR_INTEND]=yystack.l_mark[0].bool;}
break;
case 154:
#line 561 "oprs-parser.y"
	{run_option[PAR_EXEC]=yystack.l_mark[0].bool;}
break;
case 155:
#line 562 "oprs-parser.y"
	{compiler_option[CHECK_SYMBOL]=yystack.l_mark[0].bool;}
break;
case 156:
#line 563 "oprs-parser.y"
	{compiler_option[CHECK_ACTION]=yystack.l_mark[0].bool;}
break;
case 157:
#line 564 "oprs-parser.y"
	{compiler_option[CHECK_PFR]=yystack.l_mark[0].bool;}
break;
case 158:
#line 565 "oprs-parser.y"
	{compiler_option[CHECK_PFR]=yystack.l_mark[0].bool;}
break;
case 159:
#line 566 "oprs-parser.y"
	{be_quiet = yystack.l_mark[0].bool;}
break;
case 160:
#line 568 "oprs-parser.y"
	{set_user_trace(USER_TRACE,yystack.l_mark[0].bool);}
break;
case 161:
#line 569 "oprs-parser.y"
	{set_user_trace(UT_OP,yystack.l_mark[0].bool);}
break;
case 162:
#line 570 "oprs-parser.y"
	{set_user_trace(UT_INTEND,yystack.l_mark[0].bool);}
break;
case 163:
#line 571 "oprs-parser.y"
	{set_user_trace(UT_SUC_FAIL,yystack.l_mark[0].bool);}
break;
case 164:
#line 572 "oprs-parser.y"
	{set_user_trace(UT_SEND_MESSAGE,yystack.l_mark[0].bool);}
break;
case 165:
#line 573 "oprs-parser.y"
	{set_user_trace(UT_RECEIVE_MESSAGE,yystack.l_mark[0].bool);}
break;
case 166:
#line 574 "oprs-parser.y"
	{set_user_trace(UT_POST_FACT,yystack.l_mark[0].bool);}
break;
case 167:
#line 575 "oprs-parser.y"
	{set_user_trace(UT_POST_GOAL,yystack.l_mark[0].bool);}
break;
case 168:
#line 576 "oprs-parser.y"
	{set_user_trace(UT_RELEVANT_OP,yystack.l_mark[0].bool);}
break;
case 169:
#line 577 "oprs-parser.y"
	{set_user_trace(UT_SOAK,yystack.l_mark[0].bool);}
break;
case 170:
#line 578 "oprs-parser.y"
	{set_user_trace(UT_THREADING,yystack.l_mark[0].bool);}
break;
case 171:
#line 581 "oprs-parser.y"
	{debug_trace[TEXT_OP]=yystack.l_mark[0].bool;}
break;
case 172:
#line 582 "oprs-parser.y"
	{debug_trace[GRAPHIC_OP]=yystack.l_mark[0].bool;}
break;
case 173:
#line 583 "oprs-parser.y"
	{debug_trace[INTEND]=yystack.l_mark[0].bool;}
break;
case 174:
#line 584 "oprs-parser.y"
	{debug_trace[SUC_FAIL]=yystack.l_mark[0].bool;}
break;
case 175:
#line 585 "oprs-parser.y"
	{debug_trace[INTENTION_FAILURE]=yystack.l_mark[-1].cmd;}
break;
case 176:
#line 586 "oprs-parser.y"
	{debug_trace[INTENTION_FAILURE]=yystack.l_mark[-1].cmd;}
break;
case 177:
#line 587 "oprs-parser.y"
	{debug_trace[SEND_MESSAGE]=yystack.l_mark[0].bool;}
break;
case 178:
#line 588 "oprs-parser.y"
	{debug_trace[RECEIVE_MESSAGE]=yystack.l_mark[0].bool;}
break;
case 179:
#line 589 "oprs-parser.y"
	{debug_trace[POST_FACT]=yystack.l_mark[0].bool;}
break;
case 180:
#line 590 "oprs-parser.y"
	{debug_trace[POST_GOAL]=yystack.l_mark[0].bool;}
break;
case 181:
#line 591 "oprs-parser.y"
	{debug_trace[DATABASE]=yystack.l_mark[0].bool;}
break;
case 182:
#line 592 "oprs-parser.y"
	{debug_trace[CONCLUDE_FROM_PARSER]=yystack.l_mark[0].bool;}
break;
case 183:
#line 593 "oprs-parser.y"
	{debug_trace[DATABASE_FRAME]=yystack.l_mark[0].bool;}
break;
case 184:
#line 594 "oprs-parser.y"
	{debug_trace[OP_COMPILER]=yystack.l_mark[0].bool;}
break;
case 185:
#line 595 "oprs-parser.y"
	{debug_trace[RELEVANT_OP]=yystack.l_mark[0].bool;}
break;
case 186:
#line 596 "oprs-parser.y"
	{debug_trace[SOAK]=yystack.l_mark[0].bool;}
break;
case 187:
#line 597 "oprs-parser.y"
	{debug_trace[THREADING]=yystack.l_mark[0].bool;}
break;
case 188:
#line 598 "oprs-parser.y"
	{debug_trace[INTEND]=yystack.l_mark[0].bool;  
						 debug_trace[SUC_FAIL]=yystack.l_mark[0].bool;
						 debug_trace[SEND_MESSAGE]=yystack.l_mark[0].bool;
						 debug_trace[RECEIVE_MESSAGE]=yystack.l_mark[0].bool;
						 debug_trace[DATABASE]=yystack.l_mark[0].bool;
						 debug_trace[POST_FACT]=yystack.l_mark[0].bool;
						 debug_trace[POST_GOAL]=yystack.l_mark[0].bool;
						 debug_trace[THREADING]=yystack.l_mark[0].bool;
						 debug_trace[RELEVANT_OP]=yystack.l_mark[0].bool;
						 debug_trace[THREADING]=yystack.l_mark[0].bool;
						 debug_trace[SOAK]=yystack.l_mark[0].bool;}
break;
case 189:
#line 609 "oprs-parser.y"
	{enable_variable_parsing();}
break;
case 190:
#line 610 "oprs-parser.y"
	{disable_variable_parsing();}
break;
case 191:
#line 611 "oprs-parser.y"
	{warning(LG_STR("Parsing error, expecting a expr, expr or expr after \"echo\"",
								"Erreur de parsing, attendait un expr, expr or expr aprs la commande \"echo\""));}
break;
case 192:
#line 613 "oprs-parser.y"
	{add_expr(yystack.l_mark[0].expr,current_oprs);
						 disable_variable_parsing();}
break;
case 193:
#line 615 "oprs-parser.y"
	{enable_variable_parsing(); yy_begin_0();}
break;
case 194:
#line 616 "oprs-parser.y"
	{get_message(yystack.l_mark[0].expr,current_oprs,yystack.l_mark[-1].string);}
break;
case 195:
#line 617 "oprs-parser.y"
	{enable_variable_parsing(); yy_begin_0();}
break;
case 196:
#line 618 "oprs-parser.y"
	{send_message_expr(yystack.l_mark[0].expr,yystack.l_mark[-1].string);
						 disable_variable_parsing();}
break;
case 197:
#line 620 "oprs-parser.y"
	{warning(LG_STR("Parsing error, expecting a expr or a expr after add",
								"Erreur de parsing, attendait un expr or a expr aprs la commande add"));}
break;
case 198:
#line 622 "oprs-parser.y"
	{print_help_from_parser();}
break;
case 199:
#line 623 "oprs-parser.y"
	{
#ifdef OPRS_PROFILING
						 user_call_from_parser(yystack.l_mark[0].integer); 
#endif
						}
break;
case 200:
#line 628 "oprs-parser.y"
	{quit = TRUE;}
break;
case 201:
#line 629 "oprs-parser.y"
	{}
break;
case 202:
#line 630 "oprs-parser.y"
	{warning(LG_STR("Parsing error, unknown command, reseting the parser",
								"Erreur de parsing, unknown command, reseting the parser"));}
break;
case 203:
#line 635 "oprs-parser.y"
	{yy_begin_0(); enable_variable_parsing();}
break;
case 204:
#line 639 "oprs-parser.y"
	{yy_begin_0(); enable_variable_parsing();}
break;
case 205:
#line 643 "oprs-parser.y"
	{yyval.bool = TRUE;}
break;
case 206:
#line 644 "oprs-parser.y"
	{yyval.bool = FALSE;}
break;
case 207:
#line 648 "oprs-parser.y"
	{;}
break;
case 208:
#line 649 "oprs-parser.y"
	{FREE_SLIST(yystack.l_mark[-1].list);}
break;
case 209:
#line 654 "oprs-parser.y"
	{set_type_by_name(yystack.l_mark[0].string,yystack.l_mark[-2].string);}
break;
case 210:
#line 655 "oprs-parser.y"
	{;}
break;
case 211:
#line 658 "oprs-parser.y"
	{;}
break;
case 212:
#line 659 "oprs-parser.y"
	{set_type_by_name(yystack.l_mark[0].string,yystack.l_mark[-2].string);}
break;
case 213:
#line 662 "oprs-parser.y"
	{yyval.string=yystack.l_mark[0].string;}
break;
case 214:
#line 663 "oprs-parser.y"
	{set_type_by_name(yystack.l_mark[0].string,yystack.l_mark[-2].string);yyval.string=yystack.l_mark[-2].string;}
break;
case 215:
#line 667 "oprs-parser.y"
	{enable_variable_parsing(); yy_begin_0();}
break;
case 216:
#line 670 "oprs-parser.y"
	{check_pfr = FALSE;}
break;
case 217:
#line 671 "oprs-parser.y"
	{print_expr(yystack.l_mark[0].expr); free_expr(yystack.l_mark[0].expr); printf("\n");
						 check_pfr = TRUE;}
break;
case 218:
#line 678 "oprs-parser.y"
	{}
break;
case 219:
#line 679 "oprs-parser.y"
	{warning(LG_STR("Parsing error, expecting a list of expression",
									"Erreur de parsing, attendait une liste d'expression"));}
break;
case 223:
#line 689 "oprs-parser.y"
	{
#ifdef GRAPHIX
						 static int i = 0;
#endif
						 conclude(yystack.l_mark[0].expr, current_oprs->database);
						 free_expr(yystack.l_mark[0].expr);
#ifdef GRAPHIX
						 if (i++ == 35) {i = 0; process_xt_events();}
#endif
	                                      	}
break;
case 224:
#line 699 "oprs-parser.y"
	{warning(LG_STR("Parsing error, expecting a liste of expression in the database",
								"Erreur de parsing, attendait une liste d'expression dans la base de faits"));}
break;
case 225:
#line 707 "oprs-parser.y"
	{yy_begin_OPF_VERSION();}
break;
case 227:
#line 709 "oprs-parser.y"
	{warning(LG_STR("Either this is not a OP file, or this OP file version is obsolete.\n\
\tConvert it using the OP-Editor (load the file in the op-editor and then save it)\n\
\tor issue the \"op-editor -c <file-to-convert>*\" command.",
								"Ou bien ce fichier n'es pas un fichier de OP, ou cette version de format de OP est obsolte.\n\
\tSi c'est le case, convertisses le en utilisant le OP-Editor (chargez le puis sauvez le)\n\
\tou bien tapez la commande \"op-editor -c <fichier-a-convertir>*\"."));}
break;
case 229:
#line 723 "oprs-parser.y"
	{yy_begin_0();}
break;
case 231:
#line 725 "oprs-parser.y"
	{yy_begin_0();}
break;
case 232:
#line 727 "oprs-parser.y"
	{FREE_SLIST(yystack.l_mark[0].list);}
break;
case 234:
#line 729 "oprs-parser.y"
	{yy_begin_0();}
break;
case 236:
#line 733 "oprs-parser.y"
	{yyval.list = sl_make_slist();}
break;
case 237:
#line 734 "oprs-parser.y"
	{sl_add_to_tail(yystack.l_mark[-1].list,yystack.l_mark[0].string); yyval.list=yystack.l_mark[-1].list;}
break;
case 243:
#line 749 "oprs-parser.y"
	{init_make_op(yystack.l_mark[0].string,
#ifndef GRAPHIX
							      FALSE
#else
							      TRUE
#endif
							      );}
break;
case 244:
#line 758 "oprs-parser.y"
	{finish_loading_op(current_op,
#ifndef GRAPHIX
								    NULL
#else
								    global_draw_data
#endif
								    );
#ifdef GRAPHIX
						 process_xt_events();
#endif
						 if (!load_op_list || sl_in_slist(load_op_list,yystack.l_mark[-11].string)) {
                                                     add_op_to_relevant_op(current_op,current_oprs->relevant_op);
						     if (!be_quiet) printf("    %s%s\n",parser_indent,yystack.l_mark[-11].string);
                                                 } else
						     free_op(current_op);
						 disable_variable_parsing();}
break;
case 247:
#line 782 "oprs-parser.y"
	{yy_begin_NODE_TYPE();}
break;
case 249:
#line 786 "oprs-parser.y"
	{yy_begin_0();}
break;
case 250:
#line 787 "oprs-parser.y"
	{build_and_add_node(current_op, yystack.l_mark[-4].string, NT_ELSE, yystack.l_mark[-3].bool, yystack.l_mark[-2].bool, yystack.l_mark[-1].integer, yystack.l_mark[0].integer,
#ifndef GRAPHIX
								    NULL
#else
								    global_draw_data
#endif
	     );}
break;
case 251:
#line 794 "oprs-parser.y"
	{yy_begin_0();}
break;
case 252:
#line 795 "oprs-parser.y"
	{build_and_add_node(current_op, yystack.l_mark[-4].string, NT_THEN, yystack.l_mark[-3].bool, yystack.l_mark[-2].bool, yystack.l_mark[-1].integer, yystack.l_mark[0].integer,
#ifndef GRAPHIX
								    NULL
#else
								    global_draw_data
#endif
	     );}
break;
case 253:
#line 802 "oprs-parser.y"
	{yy_begin_0();}
break;
case 254:
#line 803 "oprs-parser.y"
	{build_and_add_node(current_op, yystack.l_mark[-4].string, NT_IF, yystack.l_mark[-3].bool, yystack.l_mark[-2].bool, yystack.l_mark[-1].integer, yystack.l_mark[0].integer, 
#ifndef GRAPHIX
				    NULL
#else
				    global_draw_data
#endif
				    );}
break;
case 255:
#line 810 "oprs-parser.y"
	{yy_begin_0();}
break;
case 256:
#line 811 "oprs-parser.y"
	{build_and_add_node(current_op, yystack.l_mark[-4].string, NT_PROCESS, yystack.l_mark[-3].bool, yystack.l_mark[-2].bool, yystack.l_mark[-1].integer, yystack.l_mark[0].integer, 
#ifndef GRAPHIX
				    NULL
#else
				    global_draw_data
#endif
				    );}
break;
case 257:
#line 818 "oprs-parser.y"
	{yy_begin_0();}
break;
case 258:
#line 819 "oprs-parser.y"
	{build_and_add_node(current_op, yystack.l_mark[-4].string, NT_END, yystack.l_mark[-3].bool, yystack.l_mark[-2].bool, yystack.l_mark[-1].integer, yystack.l_mark[0].integer, 
#ifndef GRAPHIX
				    NULL
#else
				    global_draw_data
#endif
				    );}
break;
case 259:
#line 826 "oprs-parser.y"
	{yy_begin_0();}
break;
case 260:
#line 827 "oprs-parser.y"
	{build_and_add_node(current_op, yystack.l_mark[-4].string, NT_START, yystack.l_mark[-3].bool, yystack.l_mark[-2].bool, yystack.l_mark[-1].integer, yystack.l_mark[0].integer, 
#ifndef GRAPHIX
				    NULL
#else
				    global_draw_data
#endif
				    );}
break;
case 261:
#line 836 "oprs-parser.y"
	{yyval.bool = yystack.l_mark[0].bool;}
break;
case 262:
#line 839 "oprs-parser.y"
	{yyval.bool = yystack.l_mark[0].bool;}
break;
case 265:
#line 848 "oprs-parser.y"
	{yy_begin_FIELD_TYPE();}
break;
case 267:
#line 852 "oprs-parser.y"
	{yy_begin_0();}
break;
case 268:
#line 853 "oprs-parser.y"
	{build_invocation(current_op, yystack.l_mark[-6].string, yystack.l_mark[-5].expr, yystack.l_mark[-4].integer, yystack.l_mark[-3].integer, yystack.l_mark[-2].bool, yystack.l_mark[-1].integer, yystack.l_mark[0].bool,
#ifndef GRAPHIX
				  NULL
#else
				  global_draw_data
#endif
				  );}
break;
case 269:
#line 860 "oprs-parser.y"
	{yy_begin_0();}
break;
case 270:
#line 861 "oprs-parser.y"
	{build_call(current_op, yystack.l_mark[-6].string, yystack.l_mark[-5].expr, yystack.l_mark[-4].integer, yystack.l_mark[-3].integer, yystack.l_mark[-2].bool, yystack.l_mark[-1].integer, yystack.l_mark[0].bool, 
#ifndef GRAPHIX
			       NULL
#else
			       global_draw_data
#endif
			       );}
break;
case 271:
#line 868 "oprs-parser.y"
	{yy_begin_0();}
break;
case 272:
#line 869 "oprs-parser.y"
	{build_context(current_op, yystack.l_mark[-6].string, yystack.l_mark[-5].list_expr, yystack.l_mark[-4].integer, yystack.l_mark[-3].integer, yystack.l_mark[-2].bool, yystack.l_mark[-1].integer, yystack.l_mark[0].bool, 
#ifndef GRAPHIX
			       NULL
#else
			       global_draw_data
#endif
			       );}
break;
case 273:
#line 876 "oprs-parser.y"
	{yy_begin_0();}
break;
case 274:
#line 877 "oprs-parser.y"
	{build_setting(current_op, yystack.l_mark[-6].string, yystack.l_mark[-5].expr, yystack.l_mark[-4].integer, yystack.l_mark[-3].integer, yystack.l_mark[-2].bool, yystack.l_mark[-1].integer, yystack.l_mark[0].bool, 
#ifndef GRAPHIX
			       NULL
#else
			       global_draw_data
#endif
			       );}
break;
case 275:
#line 884 "oprs-parser.y"
	{yy_begin_0();}
break;
case 276:
#line 885 "oprs-parser.y"
	{build_properties(current_op, yystack.l_mark[-6].string, yystack.l_mark[-5].prop_list, yystack.l_mark[-4].integer, yystack.l_mark[-3].integer, yystack.l_mark[-2].bool, yystack.l_mark[-1].integer, yystack.l_mark[0].bool, 
#ifndef GRAPHIX
				  NULL
#else
				  global_draw_data
#endif
				  );}
break;
case 277:
#line 892 "oprs-parser.y"
	{yy_begin_0();}
break;
case 278:
#line 893 "oprs-parser.y"
	{
#ifdef GRAPHIX
		     build_documentation(current_op, yystack.l_mark[-6].string, yystack.l_mark[-5].string, yystack.l_mark[-4].integer, yystack.l_mark[-3].integer, yystack.l_mark[-2].bool, yystack.l_mark[-1].integer, yystack.l_mark[0].bool, global_draw_data);
#else
		     FREE(yystack.l_mark[-5].string);
#endif
		}
break;
case 279:
#line 900 "oprs-parser.y"
	{yy_begin_0();}
break;
case 280:
#line 901 "oprs-parser.y"
	{build_effects(current_op, yystack.l_mark[-6].string, yystack.l_mark[-5].list_expr, yystack.l_mark[-4].integer, yystack.l_mark[-3].integer, yystack.l_mark[-2].bool, yystack.l_mark[-1].integer, yystack.l_mark[0].bool, 
#ifndef GRAPHIX
			       NULL
#else
			       global_draw_data
#endif
			       );}
break;
case 281:
#line 908 "oprs-parser.y"
	{yy_begin_0();}
break;
case 282:
#line 909 "oprs-parser.y"
	{build_action(current_op, yystack.l_mark[-6].string, yystack.l_mark[-5].action_field, yystack.l_mark[-4].integer, yystack.l_mark[-3].integer, yystack.l_mark[-2].bool, yystack.l_mark[-1].integer, yystack.l_mark[0].bool, 
#ifndef GRAPHIX
			      NULL
#else
			      global_draw_data
#endif
			      );}
break;
case 283:
#line 920 "oprs-parser.y"
	{yyval.integer = yystack.l_mark[0].integer;}
break;
case 284:
#line 923 "oprs-parser.y"
	{yyval.integer = yystack.l_mark[0].integer;}
break;
case 285:
#line 926 "oprs-parser.y"
	{yyval.bool = yystack.l_mark[0].bool;}
break;
case 286:
#line 929 "oprs-parser.y"
	{yyval.integer = yystack.l_mark[0].integer;}
break;
case 287:
#line 932 "oprs-parser.y"
	{yyval.bool = yystack.l_mark[0].bool;}
break;
case 288:
#line 935 "oprs-parser.y"
	{yyval.bool = (yystack.l_mark[0].integer ? TRUE : FALSE);}
break;
case 289:
#line 938 "oprs-parser.y"
	{check_symbol = TRUE;}
break;
case 290:
#line 939 "oprs-parser.y"
	{yyval.expr = yystack.l_mark[0].expr;
			        check_symbol = FALSE;}
break;
case 291:
#line 943 "oprs-parser.y"
	{yyval.expr = NULL;}
break;
case 292:
#line 944 "oprs-parser.y"
	{yyval.expr = yystack.l_mark[0].expr;}
break;
case 293:
#line 947 "oprs-parser.y"
	{yyval.list_expr = NULL;}
break;
case 294:
#line 948 "oprs-parser.y"
	{yyval.list_expr = sl_make_slist();sl_add_to_tail(yyval.list_expr,yystack.l_mark[0].expr);}
break;
case 295:
#line 949 "oprs-parser.y"
	{yyval.list_expr = yystack.l_mark[0].list_expr;}
break;
case 296:
#line 952 "oprs-parser.y"
	{yyval.expr = NULL;}
break;
case 297:
#line 953 "oprs-parser.y"
	{check_symbol = TRUE;}
break;
case 298:
#line 954 "oprs-parser.y"
	{yyval.expr = yystack.l_mark[0].expr;
			         check_symbol = FALSE;}
break;
case 299:
#line 958 "oprs-parser.y"
	{yyval.prop_list = NULL;}
break;
case 300:
#line 959 "oprs-parser.y"
	{check_symbol = TRUE;}
break;
case 301:
#line 960 "oprs-parser.y"
	{check_symbol = FALSE; yyval.prop_list = yystack.l_mark[-1].prop_list;}
break;
case 302:
#line 963 "oprs-parser.y"
	{yyval.prop_list = sl_make_slist();}
break;
case 303:
#line 964 "oprs-parser.y"
	{if (yystack.l_mark[0].prop) sl_add_to_tail(yystack.l_mark[-1].prop_list,yystack.l_mark[0].prop); yyval.prop_list=yystack.l_mark[-1].prop_list;}
break;
case 304:
#line 967 "oprs-parser.y"
	{yyval.string = NULL;}
break;
case 305:
#line 968 "oprs-parser.y"
	{yyval.string = yystack.l_mark[0].string;}
break;
case 306:
#line 973 "oprs-parser.y"
	{check_symbol = TRUE;}
break;
case 307:
#line 974 "oprs-parser.y"
	{yyval.list_expr = yystack.l_mark[0].list_expr;
			         check_symbol = FALSE;}
break;
case 308:
#line 978 "oprs-parser.y"
	{check_symbol = TRUE; yy_begin_ACTION_TYPE();}
break;
case 309:
#line 979 "oprs-parser.y"
	{yyval.action_field = yystack.l_mark[0].action_field; check_symbol = FALSE;}
break;
case 310:
#line 983 "oprs-parser.y"
	{yy_begin_0();}
break;
case 311:
#line 984 "oprs-parser.y"
	{yyval.action_field = build_action_field(yystack.l_mark[-1].expr, TRUE, FALSE, NULL, yystack.l_mark[-2].var);}
break;
case 312:
#line 985 "oprs-parser.y"
	{yy_begin_0();}
break;
case 313:
#line 986 "oprs-parser.y"
	{yyval.action_field = build_action_field(yystack.l_mark[-1].expr, TRUE, TRUE, yystack.l_mark[-3].var_list, NULL);}
break;
case 314:
#line 987 "oprs-parser.y"
	{yyval.action_field = build_action_field(yystack.l_mark[0].expr, FALSE, FALSE, NULL, NULL);}
break;
case 315:
#line 991 "oprs-parser.y"
	{yy_begin_0();}
break;
case 316:
#line 992 "oprs-parser.y"
	{yyval.expr=build_simple_action_cached(yystack.l_mark[-2].pred_func_rec,yystack.l_mark[-1].list_term);}
break;
case 319:
#line 1001 "oprs-parser.y"
	{yy_begin_EDGE_TYPE();}
break;
case 321:
#line 1002 "oprs-parser.y"
	{warning(LG_STR("Parsing error, badly formed edge",
								"Erreur de parsing, arc mal form"));}
break;
case 322:
#line 1008 "oprs-parser.y"
	{check_symbol = TRUE;}
break;
case 323:
#line 1009 "oprs-parser.y"
	{yyval.expr = yystack.l_mark[0].expr;
			         check_symbol = FALSE;}
break;
case 324:
#line 1014 "oprs-parser.y"
	{yyval.list = yystack.l_mark[-1].list;}
break;
case 325:
#line 1017 "oprs-parser.y"
	{yyval.list = sl_make_slist();}
break;
case 326:
#line 1018 "oprs-parser.y"
	{sl_add_to_tail(yystack.l_mark[-4].list,(void *)yystack.l_mark[-2].integer); sl_add_to_tail(yystack.l_mark[-4].list,(void *)yystack.l_mark[-1].integer); yyval.list = yystack.l_mark[-4].list;}
break;
case 327:
#line 1022 "oprs-parser.y"
	{yyval.string=yystack.l_mark[0].string;}
break;
case 328:
#line 1026 "oprs-parser.y"
	{yyval.string=yystack.l_mark[0].string;}
break;
case 329:
#line 1030 "oprs-parser.y"
	{yyval.string=yystack.l_mark[0].string;}
break;
case 330:
#line 1035 "oprs-parser.y"
	{yy_begin_0();}
break;
case 331:
#line 1036 "oprs-parser.y"
	{build_and_add_edge(current_op, yystack.l_mark[-8].string, yystack.l_mark[-6].string, ET_GOAL, yystack.l_mark[-5].expr, yystack.l_mark[-4].list, yystack.l_mark[-3].integer, yystack.l_mark[-2].integer, yystack.l_mark[-1].integer, yystack.l_mark[0].bool, 
#ifndef GRAPHIX
				    NULL
#else
				    global_draw_data
#endif
				    );}
break;
case 332:
#line 1043 "oprs-parser.y"
	{yy_begin_0();}
break;
case 333:
#line 1044 "oprs-parser.y"
	{build_and_add_edge(current_op, yystack.l_mark[-8].string, yystack.l_mark[-6].string, ET_IF, yystack.l_mark[-5].expr, yystack.l_mark[-4].list, yystack.l_mark[-3].integer, yystack.l_mark[-2].integer, yystack.l_mark[-1].integer, yystack.l_mark[0].bool, 
#ifndef GRAPHIX
				    NULL
#else
				    global_draw_data
#endif
				    );}
break;
case 334:
#line 1051 "oprs-parser.y"
	{yy_begin_0();}
break;
case 335:
#line 1052 "oprs-parser.y"
	{build_and_add_then_else_edge(current_op, yystack.l_mark[-2].string, yystack.l_mark[0].string, ET_ELSE, 
#ifndef GRAPHIX
					      NULL
#else
					      global_draw_data
#endif
					      );}
break;
case 336:
#line 1059 "oprs-parser.y"
	{yy_begin_0();}
break;
case 337:
#line 1060 "oprs-parser.y"
	{build_and_add_then_else_edge(current_op, yystack.l_mark[-2].string, yystack.l_mark[0].string, ET_THEN, 
#ifndef GRAPHIX
					      NULL
#else
					      global_draw_data
#endif
					      );}
break;
case 340:
#line 1072 "oprs-parser.y"
	{warning(LG_STR("Parsing error, expecting a Text OP list",
								"Erreur de parsing, attendait une liste de OP textuel"));}
break;
case 341:
#line 1076 "oprs-parser.y"
	{init_make_top(yystack.l_mark[0].string,
#ifndef GRAPHIX
							      FALSE
#else
							      TRUE
#endif
							      );}
break;
case 342:
#line 1084 "oprs-parser.y"
	{finish_loading_top(current_op,
#ifndef GRAPHIX
							      NULL
#else
							      global_draw_data
#endif
								    );
#ifdef GRAPHIX
						 process_xt_events();
#endif
						 if (!load_op_list || sl_in_slist(load_op_list,yystack.l_mark[-3].string)) {
                                                     add_op_to_relevant_op(current_op,current_oprs->relevant_op);
						     if (!be_quiet) printf("    %s%s\n",parser_indent,yystack.l_mark[-3].string);
                                                 } else
						     free_op(current_op);
						 disable_variable_parsing();}
break;
case 354:
#line 1122 "oprs-parser.y"
	{
#ifndef GRAPHIX
		build_invocation(current_op, "INVOCATION", yystack.l_mark[0].expr, 0, 0, TRUE, 0, TRUE, NULL);
#else
		build_invocation(current_op, "INVOCATION", yystack.l_mark[0].expr, ip_x, ip_y, TRUE, ip_width, TRUE, global_draw_data);
#endif
				  }
break;
case 355:
#line 1132 "oprs-parser.y"
	{
#ifndef GRAPHIX
		build_call(current_op, "CALL", yystack.l_mark[0].expr, 0, 0, TRUE, 0, TRUE,NULL);
#else
		build_call(current_op, "CALL", yystack.l_mark[0].expr, call_x, call_y, TRUE, call_width, TRUE,global_draw_data);
#endif
			       }
break;
case 356:
#line 1142 "oprs-parser.y"
	{
#ifndef GRAPHIX
		build_context(current_op, "CONTEXT", yystack.l_mark[0].list_expr, 0, 0, TRUE, 0, TRUE,NULL);
#else
		build_context(current_op, "CONTEXT", yystack.l_mark[0].list_expr, ctxt_x, ctxt_y, TRUE, ctxt_width, TRUE,global_draw_data);
#endif
			       }
break;
case 357:
#line 1152 "oprs-parser.y"
	{
#ifndef GRAPHIX
		build_setting(current_op, "SETTING", yystack.l_mark[0].expr, 0, 0, TRUE, 0, TRUE,NULL);
#else
		build_setting(current_op, "SETTING", yystack.l_mark[0].expr, set_x, set_y, TRUE, set_width, TRUE,global_draw_data);
#endif
			       }
break;
case 358:
#line 1162 "oprs-parser.y"
	{
#ifndef GRAPHIX
		build_properties(current_op, "PROPERTIES", yystack.l_mark[0].prop_list, 0, 0, TRUE, 0, TRUE,NULL);
#else
		build_properties(current_op, "PROPERTIES", yystack.l_mark[0].prop_list, prop_x, prop_y, TRUE, prop_width, TRUE,global_draw_data);
#endif
			       }
break;
case 359:
#line 1172 "oprs-parser.y"
	{
#ifndef GRAPHIX
                FREE(yystack.l_mark[0].string);
#else
		build_documentation(current_op, "DOCUMENTATION", yystack.l_mark[0].string, doc_x, doc_y, TRUE, doc_width, TRUE,global_draw_data);
#endif
			       }
break;
case 360:
#line 1182 "oprs-parser.y"
	{
#ifndef GRAPHIX
		build_effects(current_op, "EFFECTS", yystack.l_mark[0].list_expr, 0, 0, TRUE, 0, TRUE,NULL);
#else
		build_effects(current_op, "EFFECTS", yystack.l_mark[0].list_expr, eff_x, eff_y, TRUE, eff_width, TRUE,global_draw_data);
#endif
			       }
break;
case 361:
#line 1192 "oprs-parser.y"
	{
#ifndef GRAPHIX
		build_action(current_op, "ACTION", yystack.l_mark[0].action_field, 0, 0, TRUE, 0, TRUE,NULL);
#else
		build_action(current_op, "ACTION", yystack.l_mark[0].action_field, act_x, act_y, TRUE, act_width, TRUE,global_draw_data);
#endif
			       }
break;
case 362:
#line 1201 "oprs-parser.y"
	{yy_begin_COLLECT_COMMENT(); check_symbol = TRUE;}
break;
case 363:
#line 1202 "oprs-parser.y"
	{Body *to_free;
		 yy_begin_0(); check_symbol = FALSE;
		 if (yystack.l_mark[0].dn) {
		      current_op->start_point = DN_HEAD(yystack.l_mark[0].dn);
		} else {
		     current_op->start_point = make_simple_node();
		}
		 
#ifndef GRAPHIX
		build_body(current_op, "BODY", to_free = (yystack.l_mark[0].dn?DN_BODY(yystack.l_mark[0].dn):make_body(NULL)), 0, 0, TRUE, 0, TRUE, NULL);
#else
		build_body(current_op, "BODY", to_free = (yystack.l_mark[0].dn?DN_BODY(yystack.l_mark[0].dn):make_body(NULL)), bd_x, bd_y, TRUE, bd_width, TRUE, global_draw_data);
#endif
		free_double_node(yystack.l_mark[0].dn);
#ifdef OPRS_KERNEL 
#ifdef GRAPHIX
		clean_inst_sl_in_slist_og_inst(current_op->list_og_inst);
		DUP_SLIST(current_op->list_og_inst);
#endif
		free_body(to_free);
		current_op->body = NULL;		
#endif
		 if (really_build_node) current_op->start_point->type = NT_START;}
break;
case 364:
#line 1227 "oprs-parser.y"
	{if (yystack.l_mark[-1].dn) {
     						DN_BODY(yystack.l_mark[-1].dn)=make_body(DN_LIST_INST(yystack.l_mark[-1].dn));
					   		}
						 yyval.dn = yystack.l_mark[-1].dn;}
break;
case 365:
#line 1233 "oprs-parser.y"
	{yyval.dn = NULL;}
break;
case 366:
#line 1234 "oprs-parser.y"
	{yyval.dn = add_inst_to_list_inst(yystack.l_mark[-1].dn,yystack.l_mark[0].dn);}
break;
case 367:
#line 1237 "oprs-parser.y"
	{yyval.dn=yystack.l_mark[0].dn;}
break;
case 368:
#line 1238 "oprs-parser.y"
	{yyval.dn=yystack.l_mark[0].dn;}
break;
case 369:
#line 1239 "oprs-parser.y"
	{yyval.dn=yystack.l_mark[0].dn;}
break;
case 370:
#line 1240 "oprs-parser.y"
	{yyval.dn=yystack.l_mark[0].dn;}
break;
case 371:
#line 1241 "oprs-parser.y"
	{yyval.dn=yystack.l_mark[0].dn;}
break;
case 372:
#line 1242 "oprs-parser.y"
	{yyval.dn=yystack.l_mark[0].dn;}
break;
case 373:
#line 1243 "oprs-parser.y"
	{yyval.dn=yystack.l_mark[0].dn;}
break;
case 374:
#line 1244 "oprs-parser.y"
	{yyval.dn=yystack.l_mark[0].dn;}
break;
case 375:
#line 1245 "oprs-parser.y"
	{yyval.dn=yystack.l_mark[0].dn;}
break;
case 376:
#line 1248 "oprs-parser.y"
	{yyval.dn=build_inst(yystack.l_mark[0].expr);}
break;
case 377:
#line 1251 "oprs-parser.y"
	{yyval.dn=build_comment(yystack.l_mark[0].string);}
break;
case 378:
#line 1254 "oprs-parser.y"
	{yyval.dn=build_goto_inst(yystack.l_mark[0].string);}
break;
case 379:
#line 1257 "oprs-parser.y"
	{yyval.dn=build_break_inst();}
break;
case 380:
#line 1260 "oprs-parser.y"
	{yyval.dn=build_label_inst(yystack.l_mark[0].string);}
break;
case 381:
#line 1263 "oprs-parser.y"
	{yyval.dn = build_if(yystack.l_mark[-1].expr,yystack.l_mark[0].dn,NULL,FALSE);}
break;
case 382:
#line 1264 "oprs-parser.y"
	{yyval.dn = build_if(yystack.l_mark[-3].expr,yystack.l_mark[-2].dn,yystack.l_mark[0].dn,FALSE);}
break;
case 383:
#line 1265 "oprs-parser.y"
	{yyval.dn = build_if(yystack.l_mark[-3].expr,yystack.l_mark[-2].dn,yystack.l_mark[0].dn,TRUE);}
break;
case 384:
#line 1268 "oprs-parser.y"
	{yyval.dn = yystack.l_mark[-1].dn;}
break;
case 385:
#line 1271 "oprs-parser.y"
	{yyval.dn = build_while(yystack.l_mark[-2].expr,yystack.l_mark[-1].dn); parse_break_list(yyval.dn);}
break;
case 386:
#line 1274 "oprs-parser.y"
	{yyval.dn = build_do_until(yystack.l_mark[-3].dn,yystack.l_mark[-1].expr); parse_break_list(yyval.dn);}
break;
case 387:
#line 1277 "oprs-parser.y"
	{yyval.dn = build_par_branch(yystack.l_mark[-1].list);}
break;
case 388:
#line 1280 "oprs-parser.y"
	{yyval.list=sl_make_slist();}
break;
case 389:
#line 1281 "oprs-parser.y"
	{sl_add_to_tail(yystack.l_mark[-1].list,yystack.l_mark[0].dn); yyval.list = yystack.l_mark[-1].list;}
break;
case 390:
#line 1286 "oprs-parser.y"
	{yyval.var=build_var_in_frame(yystack.l_mark[0].string,LOGICAL_VARIABLE);}
break;
case 391:
#line 1287 "oprs-parser.y"
	{yyval.var=build_var_in_frame(yystack.l_mark[-2].string,LOGICAL_VARIABLE);
						 set_var_type_by_name(yystack.l_mark[0].string, yyval.var);}
break;
case 392:
#line 1289 "oprs-parser.y"
	{yyval.var=build_var_in_frame(yystack.l_mark[0].string,PROGRAM_VARIABLE);}
break;
case 393:
#line 1290 "oprs-parser.y"
	{yyval.var=build_var_in_frame(yystack.l_mark[-2].string,PROGRAM_VARIABLE);
						 set_var_type_by_name(yystack.l_mark[0].string, yyval.var);}
break;
case 394:
#line 1296 "oprs-parser.y"
	{yyval.list_expr=NULL;}
break;
case 395:
#line 1297 "oprs-parser.y"
	{yyval.list_expr=yystack.l_mark[0].list_expr;}
break;
case 396:
#line 1301 "oprs-parser.y"
	{yyval.list_expr=yystack.l_mark[-1].list_expr;}
break;
case 397:
#line 1302 "oprs-parser.y"
	{yyval.list_expr=sl_make_slist();}
break;
case 398:
#line 1306 "oprs-parser.y"
	{yyval.list_expr=sl_make_slist(); sl_add_to_tail(yyval.list_expr,yystack.l_mark[0].expr);}
break;
case 399:
#line 1307 "oprs-parser.y"
	{sl_add_to_tail(yystack.l_mark[-1].list_expr,yystack.l_mark[0].expr);yyval.list_expr=yystack.l_mark[-1].list_expr;}
break;
case 400:
#line 1311 "oprs-parser.y"
	{yyval.expr=build_expr_pfr_terms(yystack.l_mark[-2].pred_func_rec,yystack.l_mark[-1].list_term); 
	                                         if (! yyval.expr) {warning(LG_STR("badly formed expression",
									   "expression mal forme")); YYABORT;}}
break;
case 401:
#line 1314 "oprs-parser.y"
	{warning(LG_STR("badly formed expression",
								"expression mal forme")); YYABORT;}
break;
case 402:
#line 1318 "oprs-parser.y"
	{yyval.pred_func_rec = create_var_pred_func(yystack.l_mark[0].var);}
break;
case 403:
#line 1319 "oprs-parser.y"
	{yyval.pred_func_rec = find_or_create_pred_func(yystack.l_mark[0].string);}
break;
case 404:
#line 1323 "oprs-parser.y"
	{yyval.list_term=(TermList)sl_make_slist();}
break;
case 405:
#line 1324 "oprs-parser.y"
	{yyval.list_term=build_term_list(yystack.l_mark[-1].list_term,yystack.l_mark[0].term);}
break;
case 406:
#line 1327 "oprs-parser.y"
	{yyval.string=canonicalize_file_name(yystack.l_mark[0].string);}
break;
case 407:
#line 1331 "oprs-parser.y"
	{yyval.term=build_integer(yystack.l_mark[0].integer);}
break;
case 408:
#line 1332 "oprs-parser.y"
	{yyval.term=build_long_long(yystack.l_mark[0].long_long);}
break;
case 409:
#line 1333 "oprs-parser.y"
	{yyval.term=build_pointer(yystack.l_mark[0].pointer);}
break;
case 410:
#line 1334 "oprs-parser.y"
	{yyval.term=build_float(yystack.l_mark[0].real);}
break;
case 411:
#line 1335 "oprs-parser.y"
	{yyval.term=build_qstring(yystack.l_mark[0].string);}
break;
case 412:
#line 1336 "oprs-parser.y"
	{yyval.term=build_id(yystack.l_mark[0].string);}
break;
case 413:
#line 1337 "oprs-parser.y"
	{yyval.term=build_term_from_var(yystack.l_mark[0].var);}
break;
case 414:
#line 1338 "oprs-parser.y"
	{yyval.term=build_term_expr(yystack.l_mark[0].expr);}
break;
case 415:
#line 1339 "oprs-parser.y"
	{yyval.term=build_term_l_list_from_c_list(yystack.l_mark[-1].list_term);}
break;
case 416:
#line 1340 "oprs-parser.y"
	{yyval.term=build_term_array_from_c_list(yystack.l_mark[-1].list_term);}
break;
case 417:
#line 1341 "oprs-parser.y"
	{warning(LG_STR("badly formed ARRAY term",
								"ARRAY term mal forme")); YYABORT;}
break;
case 418:
#line 1343 "oprs-parser.y"
	{warning(LG_STR("badly formed composed term, bad matching [ )",
								"composed term mal forme, mauvaise correspondance [ )")); YYABORT;}
break;
case 419:
#line 1345 "oprs-parser.y"
	{warning(LG_STR("badly formed composed term, bad matching [ .)",
								"composed term mal forme, mauvaise correspondance [ .)")); YYABORT;}
break;
case 420:
#line 1347 "oprs-parser.y"
	{warning(LG_STR("badly formed composed term",
								"composed term mal forme")); YYABORT;}
break;
case 421:
#line 1349 "oprs-parser.y"
	{warning(LG_STR("badly formed composed term, bad matching ( .)",
								"composed term mal forme, mauvaise correspondance ( .)")); YYABORT;}
break;
case 422:
#line 1351 "oprs-parser.y"
	{warning(LG_STR("badly formed composed term, bad matching ( ]",
								"composed term mal forme, mauvaise correspondance ( ]")); YYABORT;}
break;
case 423:
#line 1353 "oprs-parser.y"
	{warning(LG_STR("badly formed LISP_LIST term",
								"LISP_LIST term mal forme")); YYABORT;}
break;
case 424:
#line 1355 "oprs-parser.y"
	{warning(LG_STR("badly formed composed term, bad matching (. )",
								"composed term mal forme, mauvaise correspondance (. )")); YYABORT;}
break;
case 425:
#line 1357 "oprs-parser.y"
	{warning(LG_STR("badly formed composed term, bad matching (. ]",
								"composed term mal forme, mauvaise correspondance (. ]")); YYABORT;}
break;
case 426:
#line 1362 "oprs-parser.y"
	{yyval.var_list=(VarList)sl_make_slist(); sl_add_to_head(yyval.var_list,yystack.l_mark[0].var);}
break;
case 427:
#line 1363 "oprs-parser.y"
	{sl_add_to_tail(yystack.l_mark[-1].var_list,yystack.l_mark[0].var); yyval.var_list=yystack.l_mark[-1].var_list;}
break;
case 428:
#line 1370 "oprs-parser.y"
	{yyval.prop=build_property(yystack.l_mark[-2].string,yystack.l_mark[-1].term);}
break;
case 429:
#line 1372 "oprs-parser.y"
	{warning(LG_STR("expecting a term after a property name",
								"attendait un term aprs un nom de proprit")); YYABORT;}
break;
case 430:
#line 1374 "oprs-parser.y"
	{warning(LG_STR("expecting a property name",
								"attendait un mnom de proprit")); YYABORT;}
break;
case 431:
#line 1379 "oprs-parser.y"
	{yyval.string=yystack.l_mark[0].string;}
break;
case 432:
#line 1386 "oprs-parser.y"
	{yyval.string=canonicalize_read_file_name(yystack.l_mark[0].string);}
break;
case 433:
#line 1389 "oprs-parser.y"
	{yyval.string=yystack.l_mark[0].string;}
break;
#line 3796 "oprs-parser.c"
    }
    yystack.s_mark -= yym;
    yystate = *yystack.s_mark;
    yystack.l_mark -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yystack.s_mark = YYFINAL;
        *++yystack.l_mark = yyval;
        if (yychar < 0)
        {
            yychar = YYLEX;
            if (yychar < 0) yychar = YYEOF;
#if YYDEBUG
            if (yydebug)
            {
                if ((yys = yyname[YYTRANSLATE(yychar)]) == NULL) yys = yyname[YYUNDFTOKEN];
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == YYEOF) goto yyaccept;
        goto yyloop;
    }
    if (((yyn = yygindex[yym]) != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == (YYINT) yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yystack.s_mark, yystate);
#endif
    if (yystack.s_mark >= yystack.s_last && yygrowstack(&yystack) == YYENOMEM) goto yyoverflow;
    *++yystack.s_mark = (YYINT) yystate;
    *++yystack.l_mark = yyval;
    goto yyloop;

yyoverflow:
    YYERROR_CALL("yacc stack overflow");

yyabort:
    yyfreestack(&yystack);
    return (1);

yyaccept:
    yyfreestack(&yystack);
    return (0);
}
